#include <types.h>

#include <mach/SAMA5D3X.h>
#include <mach/SAMA5D3Xbd.h>


#include <console.h>

#define	OEM_DEBUG_READ_NODATA	(-1)
#define	OEM_DEBUG_COM_ERROR		(-2)

//#define DEBUG_BAUD_38400		0x00000006
//#define DEBUG_BAUD_57600		0x00000004
//#define DEBUG_BAUD_112500		0x00000002

#define DBGU_BAUDRATE	(115200)
#define AT91C_US_ASYNC_MODE ( AT91C_US_USMODE_NORMAL + \
                        AT91C_US_NBSTOP_1_BIT + \
                        AT91C_US_PAR_NONE + \
                        AT91C_US_CHRL_8_BITS + \
                        AT91C_US_CLKS_CLOCK )

/// pointer to the Debug Serial controller
STATIC AT91PS_DBGU g_pDBGU = (AT91PS_DBGU)AT91C_BASE_DBGU;

/*****************************************************************************
*
*
*   @func   VOID    |   ser_init | Initialize serial.
*
*   NOTE: This function MUST NOT use any global variables!!!!!!
*/

VOID ser_putch(BYTE c) 
{
	if (g_pDBGU == NULL)
		return;

	while (!(g_pDBGU->DBGU_SR & DBGU_SR_TXRDY))
	{
		//do nothing. wait for the controller to be ready
	}
	g_pDBGU->DBGU_THR = c;
	while (!(g_pDBGU->DBGU_SR & DBGU_SR_TXRDY))
	{
		//do nothing. wait for the controller to be ready
	}
}

void test(void)
{
    for(;;) ser_putch('/');
}


INT32 ser_getc( VOID )
{
	INT32   data;

	data=OEM_DEBUG_READ_NODATA;

	if (g_pDBGU == NULL)
	{
		return data;
	}

	if (g_pDBGU->DBGU_SR & DBGU_SR_RXRDY) //Did we receive at least one byte ?
	{
		data = g_pDBGU->DBGU_RHR; //If so return its value
	}

	return data; //If not so, return the no data flag
}

INT32 ser_getch(VOID)
{
	INT32 ret;
	do
	{
		ret = ser_getc();
	}while(ret < 0);

	return ret;
}


VOID ser_put_str(CHAR *str, INT32 nr) 
{
    // Send message to serial port
    while (*str) 
	{
		ser_putch((BYTE)*str++);
	}		
}


//STATIC UINT32 
//AT91SAM926x_GetMasterClock(BOOL bUseShadowedValue)
//{        
//    STATIC UINT32 dwMasterClock = 0xFFFFFFFF;
//
//    if ((dwMasterClock == 0xFFFFFFFF) || (!bUseShadowedValue))
//    {        
//        
//		DWORD temp;
//		DWORD dwInputFreq;	    
//		AT91PS_PMC pPMC;
//		pPMC = (AT91PS_PMC)AT91C_BASE_PMC;
//		switch (pPMC->PMC_MCKR & AT91C_PMC_CSS)
//		{
//			case AT91C_PMC_CSS_SLOW_CLK: dwInputFreq = SLOW_CLOCK_FREQUENCY; break;
//			case AT91C_PMC_CSS_MAIN_CLK: dwInputFreq = GetMainClockFreq(pPMC); break;
//			case AT91C_PMC_CSS_PLLA_CLK: dwInputFreq = GetPLLAFreq(pPMC); break;
//			case AT91C_PMC_CSS_PLLB_CLK: dwInputFreq = GetPLLBFreq(pPMC); break;
//		}
//
//        if (dwInputFreq != 0)
//		{
//			temp = dwInputFreq >> ((pPMC->PMC_MCKR & AT91C_PMC_PRES)>>2);
//			dwMasterClock = temp >> ((pPMC->PMC_MCKR & AT91C_PMC_MDIV) >> 8);
//		}
//		        
//    }           
//    console_printf("Master Clock is %d Hz\r\n",dwMasterClock);
//    return dwMasterClock;    
//
//}

#define AT91C_MASTER_CLOCK              48000000

PUBLIC VOID 
ConsoleInit( VOID ) 
{
#if 0
	UINT32              dwMasterClock;  
	AT91PS_USART pUSART = (AT91PS_USART) AT91C_BASE_DBGU;
//	AT91PS_PDC pPDC = (AT91PS_PDC) &(pUSART->US_RPR);
//	AT91PS_PIO pPioA = (AT91PS_PIO) AT91C_BASE_PIOA;

    g_pDBGU = (AT91PS_DBGU)AT91C_BASE_DBGU;

	dwMasterClock = BOARD_MCK;

	//
	// Init the DBGU
	//
	// Configure PIO controllers to periph mode	   	
//	pPioA->PIO_PDR = (AT91C_PB12_DRXD | AT91C_PB13_DTXD);
//	pPioA->PIO_ASR = (AT91C_PB12_DRXD | AT91C_PB13_DTXD);


	//Configure USART
	
	//* Disable interrupts
    pUSART->US_IDR = (unsigned int) -1;

    //* Reset receiver and transmitter
    pUSART->US_CR = AT91C_US_RSTRX | AT91C_US_RSTTX | AT91C_US_RXDIS | AT91C_US_TXDIS ;

	//* Define the baud rate divisor register
	{
		unsigned int baud_value = ((dwMasterClock*10)/(DBGU_BAUDRATE * 16));
		if ((baud_value % 10) >= 5)
			baud_value = (baud_value / 10) + 1;
		else
			baud_value /= 10;
		 pUSART->US_BRGR = baud_value;
	}

	//* Write the Timeguard Register
	pUSART->US_TTGR = 0;

    //* Clear Transmit and Receive Counters

    //* Disable the RX and TX PDC transfer requests
/*
	pPDC->PDC_PTCR = AT91C_PDC_RXTDIS;
	pPDC->PDC_PTCR = AT91C_PDC_TXTDIS;

	//Reset all Counter register Next buffer first
	pPDC->PDC_TNPR = 0;
	pPDC->PDC_TNCR = 0;
	pPDC->PDC_RPR = 0;
	pPDC->PDC_RCR = 0;
	pPDC->PDC_RPR = 0;
	pPDC->PDC_RCR = 0;
	pPDC->PDC_TPR = 0;
	pPDC->PDC_TCR = 0;

    //Enable the RX and TX PDC transfer requests
	pPDC->PDC_PTCR = AT91C_PDC_RXTEN;
	pPDC->PDC_PTCR = AT91C_PDC_TXTEN;
*/
    //* Define the USART mode
    pUSART->US_MR = AT91C_US_ASYNC_MODE  ;

	// Enable Transmitter
	pUSART->US_CR = AT91C_US_RXEN;
	pUSART->US_CR = AT91C_US_TXEN;
#endif
}


PUBLIC INT32 
ConsoleRead( PBYTE p_Buffer, INT32 n)
{
	INT32   Ret;
	INT32   i=0;	
	for(; n > 0; n--)
	{
		do
		{
			Ret = ser_getc();
			if( ( Ret == OEM_DEBUG_COM_ERROR) )
				return i;
		}while(Ret < 0);
		
		*p_Buffer++ = (BYTE)Ret;
		i++;
	}
	
	return i;
}

PUBLIC VOID 
ConsolePutChar( BYTE Ch ) 
{
    ser_putch(Ch);
	
	if (Ch=='\n') ConsolePutChar('\r');

}

PUBLIC VOID 
ConsoleWrite( PBYTE p_Str) 
{
    // Send message to serial port
    while (*p_Str) 
	{
		if(*p_Str == '\n')	ser_putch((BYTE)('\r'));

		ser_putch((BYTE)*p_Str++);
	}		
}


INT32 getcommand( CHAR *command)
{
	INT32 ret;
	INT32 nrcv = 0;
	
	do
	{
		do
		{
			ret = ser_getc();
			if( ( ret == OEM_DEBUG_COM_ERROR) )
				return 0;
		}while(ret < 0);

		if( (CHAR)ret == '\r')
			ret = 0;
		
		*command = (CHAR)ret;
		
		if( ret != 0 )
		{
			if( (CHAR)ret == 0x08 )
			{
				if( nrcv > 0)
				{
					nrcv--;
					command--;
					console_printf("%c",(char)ret);
					console_printf("%c",(CHAR)' ');
					console_printf("%c",(CHAR)ret);
				}
			}
			else
			{
				nrcv++;
				command++;
				console_printf("%c",(CHAR)ret);
			}
			
		}
		else
			console_printf("\n");
		
	}while(ret != 0);
	
	return 1;

}

