typedef enum {
	ACT_PGM,
	ACT_ERASE,
	ACT_LOCK,
	ACT_UNLOCK,
	ACT_WRITE_BUF,
}FLASH_ACTION;





#define FLASH_BASE          0x40000000
#define FLASH_SIZE		    0x80000
#define Flash_Code		    0x00BF
#define Flash_256KB		    0x2789
#define Flash_512KB		    0x2780
#define Flash_1M		    0x2781
#define FBOUND			    0x2
#define FLASH_BLOCK_SIZE 	0x00010000
#define FLASH_SECTOR_SIZE 	0x1000
 	







/*-----------------
Word-Program
--------------------*/
#define WORD_PRG_ADDR1		0x5555
#define WORD_PRG_ADDR2		0x2AAA
#define WORD_PRG_ADDR3		0x5555


		
#define WORD_PRG_CMD1		0xAAAA
#define WORD_PRG_CMD2		0x5555
#define WORD_PRG_CMD3		0xA0A0

/*-----------------
Sector-Erase
--------------------*/
#define SEC_ERASE_ADDR1		0x5555
#define SEC_ERASE_ADDR2		0x2AAA
#define SEC_ERASE_ADDR3		0x5555
#define SEC_ERASE_ADDR4		0x5555
#define SEC_ERASE_ADDR5		0x2AAA
                                                                                     


#define SEC_ERASE_CMD1		0xAAAA
#define SEC_ERASE_CMD2		0x5555
#define SEC_ERASE_CMD3		0x8080
#define SEC_ERASE_CMD4		0xAAAA
#define SEC_ERASE_CMD5		0x5555
#define SEC_ERASE_CMD6		0x3030

/*-----------------
Block-Erase
--------------------*/

#define BLOCK_ERASE_ADDR1	0x5555
#define BLOCK_ERASE_ADDR2	0x2AAA
#define BLOCK_ERASE_ADDR3	0x5555
#define BLOCK_ERASE_ADDR4	0x5555
#define BLOCK_ERASE_ADDR5	0x2AAA
                                                                                     


#define BLOCK_ERASE_CMD1	0xAAAA
#define BLOCK_ERASE_CMD2	0x5555
#define BLOCK_ERASE_CMD3	0x8080
#define BLOCK_ERASE_CMD4	0xAAAA
#define BLOCK_ERASE_CMD5	0x5555
#define BLOCK_ERASE_CMD6	0x5050


/*-----------------
Chip-Erase
--------------------*/

#define CHIP_ERASE_ADDR1	0x5555
#define CHIP_ERASE_ADDR2	0x2AAA
#define CHIP_ERASE_ADDR3	0x5555
#define CHIP_ERASE_ADDR4	0x5555
#define CHIP_ERASE_ADDR5	0x2AAA
#define CHIP_ERASE_ADDR6	0x5555


#define CHIP_ERASE_CMD1		0xAAAA
#define CHIP_ERASE_CMD2		0x5555
#define CHIP_ERASE_CMD3		0x8080
#define CHIP_ERASE_CMD4		0xAAAA
#define CHIP_ERASE_CMD5		0x5555
#define CHIP_ERASE_CMD6		0x1010


/*----------------
CFI Query Entry
------------------*/
#define CFI_READ_ADDR1		0x5555
#define CFI_READ_ADDR2		0x2AAA
#define CFI_READ_ADDR3		0x5555


#define CFI_READ_CMD1		0xAAAA
#define CFI_READ_CMD2		0x5555
#define CFI_READ_CMD3		0x9898


/*-----------------
Software ID Entry
--------------------*/
#define SWID_READ_ADDR1		0x5555
#define SWID_READ_ADDR2		0x2AAA
#define SWID_READ_ADDR3		0x5555


#define SWID_READ_CMD1		0xAAAA
#define SWID_READ_CMD2		0x5555
#define SWID_READ_CMD3		0x9090

/*-----------------
Software ID Exit/CFI Exit
--------------------*/
//#define		SW_CFI_EXIT_CMD1	0xF0

#define SW_CFI_EXIT_ADDR1	0x5555
#define SW_CFI_EXIT_ADDR2	0x2AAA
#define SW_CFI_EXIT_ADDR3	0x5555

#define SW_CFI_EXIT_CMD1	0xAAAA
#define SW_CFI_EXIT_CMD2	0x5555
#define SW_CFI_EXIT_CMD3	0xF0F0



