#ifndef _NETDEV_H
#define _NETDEV_H

#include <types.h>
#include <net/buflist.h>

#define htonl(x)	(((x) & 0x000000ff) << 24 |\
			 ((x) & 0x0000ff00) << 8  |\
			 ((x) & 0x00ff0000) >> 8  |\
			 ((x) & 0xff000000) >> 24)

#define htons(x)	(((x) & 0x000000ff) << 8 |\
			 ((x) & 0x0000ff00) >> 8)

typedef enum {
	media_autodetect,
	media_coax,
	media_utp,
	media_aui
} media_t;

struct netdev;

struct netdev_ops {
	int		(*init)(void);
	int		(*open)(struct netdev *);
	int		(*send)(struct netdev *, void *buffer, int size);
	int		(*recv)(struct netdev *, void *buf, int size);
	const char	*driver_name;
};

struct trans_ops {
	struct buflist *(*header)(struct netdev *nd, BYTE *dest, UINT16 proto, struct buflist *blp);
	int		(*send)(struct netdev *nd, struct buflist *blp);
	int		(*recv)(struct netdev *nd, UINT16 proto, BYTE *buf);
};

struct netdev {
	const struct netdev_ops	*hard;
	const struct trans_ops	*trans;

	const		char *name;

/*	struct netdev	*next; */
	UINT32		io_base;
	BYTE		hw_addr[6];
	BYTE		hw_broadcast[6];
	BYTE		hw_addr_len;

	UINT32		ip_addr;

	media_t		media;
};

extern struct netdev *selected_net_devs;

#endif
