/*	$ JBOSN: types.h, v 0.1 2002/12/17 $	*/

/*
 * Copyright (C) 2002	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: types.h
 *
 * Purpose: Type definitions.
 *
 */

/* Useful typedefs */

#ifndef __JBOSN_TYPES_H_
#define __JBOSN_TYPES_H_


/* The left side of these typedefs are machine and compiler dependent */
typedef signed   char           CHAR;
typedef signed   short          WCHAR;
typedef signed   short          SHORT;
typedef signed   int            INT;
typedef unsigned char           UCHAR;
typedef unsigned short          USHORT;
typedef unsigned int            UINT;
typedef CHAR                   *PCHAR;
typedef WCHAR                  *PWCHAR;
typedef SHORT                  *PSHORT;
typedef INT                    *PINT;
typedef UCHAR                  *PUCHAR;
typedef USHORT                 *PUSHORT;
typedef UINT                   *PUINT;

typedef signed   char          INT8;
typedef signed   short         INT16;
typedef signed   int           INT32;
typedef signed   long long     INT64;
typedef unsigned char          UINT8;
typedef unsigned short         UINT16;
typedef unsigned int           UINT32;
typedef unsigned long long     UINT64;

typedef INT8                   *PINT8;
typedef INT16                  *PINT16;
typedef INT32                  *PINT32;
typedef INT64                  *PINT64;
typedef UINT8                  *PUINT8;
typedef UINT16                 *PUINT16;
typedef UINT32                 *PUINT32;
typedef UINT64                 *PUINT64;


typedef void                    VOID;
typedef void                   *PVOID;

typedef UINT32                  BOOL;
typedef UCHAR                   BYTE;
typedef UCHAR                  *PBYTE;
typedef USHORT                  WORD;
typedef UINT32                  DWORD;
typedef UINT64                  DDWORD;
typedef CHAR                    SBYTE;
typedef SHORT                   SWORD;
typedef INT                     SDWORD;

typedef UINT32                  JB_ERR;

typedef UINT32                  HANDLE;

#define CONST                   const
#define PUBLIC			
#define PRIVATE                 static
#define STATIC                  static
#define EXTERN                  extern
#define INLINE                  inline
#define VOLATILE                volatile

#define TRUE                    (1)
#define FALSE                   (0)
#define NULL                    (0)

#endif /* __JBOSN_TYPES_H_ */

