
#ifndef _DRV_DISPLAY_H_
#define _DRV_DISPLAY_H_

#include <mach/sama5d3Xbd.h>
#include <mach/hal_interrupt.h>


#ifdef  __800x480__

    #define DISPLAY_WIDTH               800
    #define DISPLAY_HEIGHT              480

    /** Frame rate in Hz. */
    #define BOARD_LCD_FRAMERATE         30

    /** Vertical front porch in number of lines. */
    #define BOARD_LCD_TIMING_VFP        23 
    /** Vertical back porch in number of lines. */
    #define BOARD_LCD_TIMING_VBP        12 
    /** Vertical pulse width in number of lines. */
    #define BOARD_LCD_TIMING_VPW        10
    /** Horizontal front porch in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HFP        46
    /** Horizontal back porch in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HBP        25 //46
    /** Horizontal pulse width in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HPW        20

#else
#ifdef __800x600__

    #define DISPLAY_WIDTH               800
    #define DISPLAY_HEIGHT              600

    /** Frame rate in Hz. */
    #define BOARD_LCD_FRAMERATE         40

    /** Vertical front porch in number of lines. */
    #define BOARD_LCD_TIMING_VFP        23 //22
    /** Vertical back porch in number of lines. */
    #define BOARD_LCD_TIMING_VBP        12 //21
    /** Vertical pulse width in number of lines. */
    #define BOARD_LCD_TIMING_VPW        10
    /** Horizontal front porch in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HFP        46
    /** Horizontal back porch in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HBP        25
    /** Horizontal pulse width in LCDDOTCLK cycles. */
    #define BOARD_LCD_TIMING_HPW        20
#endif
#endif
    
#define DISPLAY_BPP                 (32)
#define DISPLAY_STRIDE              (DISPLAY_WIDTH<<2)

//====================================================================

#define DMA_ADDR_OFFSET         0x20000000

/** Frequency of the board main oscillator */
#define BOARD_MAINOSC           12000000

/** Master clock frequency (when using board_lowlevel.c) */
//#define BOARD_MCK                ((unsigned long)((BOARD_MAINOSC / 3 / 2 / 3) * 200 ))



/** Pixel clock rate in Hz (HS period * VS period * BOARD_LCD_FRAMERATE). */
#define BOARD_LCD_PIXELCLOCK        ((BOARD_LCD_TIMING_HPW+BOARD_LCD_TIMING_HBP+DISPLAY_WIDTH+BOARD_LCD_TIMING_HFP)*(BOARD_LCD_TIMING_VPW+BOARD_LCD_TIMING_VBP+DISPLAY_HEIGHT+BOARD_LCD_TIMING_VFP)*BOARD_LCD_FRAMERATE)


typedef struct {
    UINT32 addr;
    UINT32 ctrl;
    UINT32 next;
}LCDC_DESC, *LCDC_PDESC;



#endif // _DRV_DISPLAY_H_

































