#include <types.h>
#include <moduleloader.h>
#include <console.h>

#include "cmd_nand.h"
#include <mach/sama5d3xbd.h>


EXTERN INT32 ston(CHAR *s);
EXTERN INT32 recvXModem(BYTE *buf, INT32 bufsize);
EXTERN INT32 recvZModem(CONST CHAR *name, UINT32 addr);


EXTERN CHAR *__PULL();

EXTERN INT32 UncompressKernel( char *s, char *d, UINT32, UINT32);

EXTERN INT32 recvZModem(CONST CHAR *name, UINT32 addr);
EXTERN VOID recvTFTP( UINT32 address );

#ifdef USE_ZMODEM
VOID zdownload( VOID )
{
        INT32            size;
	BYTE 	*pbuf;
	CHAR		*token;
	//CHAR		addressbuf[] = "0xc0000000";
	
	token = __PULL() ;
								
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an download address\n");
		
		pbuf = (BYTE *)0x40000000;
	}
	else
	{
		pbuf = (BYTE *)ston(token);
	}
	
	 // ZModemAEˢˢI IiˢIAIAEE| IoעϢEIAEIU.
    size = recvZModem("test.txt",(UINT32)pbuf );
    	
    if( size == -1 ) 
    {
            console_printf( "ZModem Receive Error!\n" );
    }
    else
    {
            console_printf( "\nZModem Receive Size %d\n", size );
    }

	return;
}
#endif


#ifdef USE_XMODEM
VOID xdownload( VOID )
{
	BYTE 	*pbuf;
	CHAR		*token;

	token = __PULL() ;
								
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an download address\n");
		pbuf = (BYTE *)0x40000000;
		//pbuf = (BYTE *)0x40144000;
	}
	else
	{
	    pbuf = (BYTE *)ston(token);
	}
	
	recvXModem(pbuf, 0x800000);
	
	return;
}
#endif

#ifdef USE_NET
VOID ldownload( VOID )
{
	CHAR	*token;

	token = __PULL() ;
								
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an download address\n");
		return ;
	}

	recvTFTP( (UINT32)ston(token) );

	return;
}
#endif


#if 1

#define SFLASH_PAGE_SHIFT   (12)
#define SFLASH_PAGE_SIZE    (1<<SFLASH_PAGE_SHIFT)
#define SFLASH_PAGE_MASK    (SFLASH_PAGE_SIZE-1)
typedef struct 
{
    UINT32      nPage;
    BYTE        Data[4096];
}PAGE_CACHE, *PPAGE_CACHE;


STATIC PAGE_CACHE       SectorCache;

#define ROM_BASE        0x40000
PUBLIC UINT32
PlatformReadFunction(PBYTE pBuffer, UINT32 StartOffset, INT32 ReadLen )
{

    UINT32  nRet = 0;
    UINT32  nPage;
    UINT32  Offset;
    UINT32  nCopy;

    nPage = ( (ROM_BASE + StartOffset) >> SFLASH_PAGE_SHIFT);
    Offset = StartOffset & SFLASH_PAGE_MASK;

    for( ;ReadLen > 0; )
    {
        if( nPage != SectorCache.nPage )
        {
            // read page
            SectorCache.nPage = nPage;
            int ret;
            ret = read_dataflash( SectorCache.Data, nPage << SFLASH_PAGE_SHIFT, SFLASH_PAGE_SIZE);
        }

        nCopy = SFLASH_PAGE_SIZE - Offset;

        if( nCopy > ReadLen )
            nCopy = ReadLen;

        memcpy( pBuffer, SectorCache.Data + Offset, nCopy );
        pBuffer += nCopy;
        Offset = 0;
        ReadLen -= nCopy;
        nRet += nCopy;
        nPage++;
    }

    return  nRet;
}

/*
#define ROM_BASE        0x20000
PUBLIC UINT32
PlatformReadFunction(PBYTE pBuffer, UINT32 StartOffset, INT32 ReadLen )
{
    int ret;

console_printf("\n download : pBuffer = %x ", pBuffer);
console_printf("(%x ", StartOffset);
console_printf("%d)\n ", ReadLen);
    ret = read_dataflash( pBuffer, StartOffset + ROM_BASE, ReadLen);
console_printf("ret = %d\n ", ret);
console_printf("%2.2x ", pBuffer[0]);
console_printf("%2.2x ", pBuffer[1]);
console_printf("%2.2x ", pBuffer[2]);
console_printf("%2.2x ", pBuffer[3]);
console_printf("%2.2x ", pBuffer[4]);
console_printf("%2.2x ", pBuffer[5]);
console_printf("%2.2x ", pBuffer[6]);
console_printf("%2.2x\n ", pBuffer[7]);
    if( ret < 0 )
        return 0;

{
    BYTE Buffer[52];
    ret = read_dataflash( Buffer, 0x510c0 + ROM_BASE, 52);
console_printf("d0 = %d\n ", ret);
console_printf("%2.2x ", Buffer[16+0]);
console_printf("%2.2x ", Buffer[16+1]);
console_printf("%2.2x ", Buffer[16+2]);
console_printf("%2.2x ", Buffer[16+3]);
console_printf("%2.2x ", Buffer[16+4]);
console_printf("%2.2x ", Buffer[16+5]);
console_printf("%2.2x ", Buffer[16+6]);
console_printf("%2.2x\n ", Buffer[16+7]);
    
}

    return ReadLen;
}
*/
#else

#define ROM_BASE        0x2FC00000
PUBLIC UINT32
PlatformReadFunction(PBYTE pBuffer, UINT32 StartOffset, INT32 ReadLen )
{
    memcpy( pBuffer, ROM_BASE + StartOffset, ReadLen );

    return  ReadLen;
}

#endif

UINT32 platform_start;
VOID rdownload( VOID )
{
    INT32           i;
    UINT32          nRead;
    UINT32          UploadAdd;
    PSHARED_MEMORY  pSharedMemory = (PSHARED_MEMORY)SHARED_MEMORY_BASE;
//console_printf("\n download the platform.bin \n");
//console_printf("\n pSharedMemory = %x \n", pSharedMemory);

    UploadAdd = 0x20009000;

    /* read the platform.bin location */
    nRead = LoadPlatformLen( UploadAdd, PlatformReadFunction, 8 );
//    console_printf("\n download the platform.bin : bRet = %x\n", nRead);

//    if( nRead )
//        console_printf("-> SUCCESS\n\n");
//    else
//        console_printf("-> FAIL\n\n");

    platform_start = *(PUINT32)(UploadAdd + 0);
//console_printf("\n Loading the platform_start : %x", platform_start);
    UploadAdd = *(PUINT32)(UploadAdd + 4);
//console_printf("\n Loading the UploadAdd : %x", UploadAdd);


    /* read the platform.bin */
    nRead = LoadPlatform( platform_start, PlatformReadFunction );
//    console_printf("\n download the platform.bin : bRet = %x\n", nRead);
//
//    if( nRead )
//        console_printf("-> SUCCESS\n\n");
//    else
//        console_printf("-> FAIL\n\n");

    LCDD_PowerOn();

    /* read the kernels */
    UploadAdd = (UploadAdd + 0x3) & (~0x3);
//console_printf( "KernelLoad : UploadAdd = %x\n", UploadAdd );

    for( i = 0 ; i < MAX_KERNEL_MODULE_LOAD; i++ )
        pSharedMemory->aKernelLoaded[i] = -1;

//    pSharedMemory->aKernelLoaded[0] = 0xE0300000;       // nano : 4000
//    pSharedMemory->aKernelLoaded[1] = pSharedMemory->aKernelLoaded[0] + 0x04000; // time : 1228
//    pSharedMemory->aKernelLoaded[2] = pSharedMemory->aKernelLoaded[1] + 0x02000; // system : 1D34
//    pSharedMemory->aKernelLoaded[3] = pSharedMemory->aKernelLoaded[2] + 0x02000; // sync : 1F10
//    pSharedMemory->aKernelLoaded[4] = pSharedMemory->aKernelLoaded[3] + 0x02000; // IO : E64
//    pSharedMemory->aKernelLoaded[5] = pSharedMemory->aKernelLoaded[4] + 0x01000; // FS : 32cc
//    pSharedMemory->aKernelLoaded[6] = pSharedMemory->aKernelLoaded[5] + 0x04000; // WN : 5770
//    //pSharedMemory->aKernelLoaded[7] = pSharedMemory->aKernelLoaded[6] + 0x06000; // NW : 1250c
//    //pSharedMemory->aKernelLoaded[8] = pSharedMemory->aKernelLoaded[7] + 0x13000; // loader : 3024
    pSharedMemory->aKernelLoaded[0] = 0;

    LoadKernel( UploadAdd, pSharedMemory->aKernelLoaded, PlatformReadFunction, 0x02100000 /* temporary heap*/);

//    for( i = 0; i < MAX_KERNEL_MODULE; i++ )
//    {
//        //console_printf( "aLoaded = %X\n", pSharedMemory->aKernelLoaded[i] );
//        //if( aKernelLoaded[i] == -1 )
//        if( i > 0 )
//        {
//            //KernelConfig[i-1].pFunc = (THREADFUNC)aKernelLoaded[i];
//        }
//    }

    EXTERN LOADER_CONFIG  RomLoaderConfig;
    pSharedMemory->LoaderConfig = RomLoaderConfig;

//console_printf( "rdownload : Open = %x\n", RomLoaderConfig.pOpen );
//console_printf( "rdownload : Read = %x\n", RomLoaderConfig.pRead );
//console_printf( "rdownload : CacheRangeFlush = %x\n", RomLoaderConfig.pCacheRangeFlush );

//console_printf( "rdownload : UploadAdd = %x\n", UploadAdd );
    
    return;
}



#ifdef USE_GDN
VOID gdownload( VOID )
{
    unsigned int    *pSrcBuf;
    unsigned int    *pDstBuf = (unsigned int *)0x21800000;
	CHAR		    *token;

	token = __PULL() ;
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an download source address\n");
		pSrcBuf = (unsigned int *)0x20500000;
	}
	else
	{
	    pSrcBuf = (unsigned int *)ston(token);
	}
console_printf( "\ngdownload pSrcBuf %X\n", pSrcBuf );
/*
{
    int vRet;
    INT32   nPage;
    PBYTE   pBuf = (PBYTE)pSrcBuf;

    nPage = 0;
    for( ; pBuf < 0x21000000 ; )
    {
        vRet = LLD_ReadSector(nPage++, pBuf);
        if( vRet < 0 ) console_printf("read_dataflash = %d\n", vRet);
        pBuf += NANDFLASH_PAGESIZE;
    }
}
*/

    UncompressKernel( (char *)pSrcBuf, (char *)pDstBuf, 0x20000000, 0x20100000 );

	{
	    unsigned int    i;
	    unsigned int    *pbase;
	    unsigned int    length;

        do
        {
            pbase = (unsigned int *)*pDstBuf;
            pDstBuf ++;
            length  = *pDstBuf;
            pDstBuf ++;

console_printf( "\nrdownload pbase  %X\n", pbase );
            length = (length + 3) & ~0x3;
console_printf( "\nrdownload length %X\n", length );

            for( i = 0 ; i < length ; i+=4)
            {
                *pbase++ = *pDstBuf++;
            }
        }while( length != 0);  

    }

	return;
}
#endif
