#include <types.h>
#include <flash_amic.h>



void Delay(int i)
{
	while(--i);
}	

void Check_Toggle_Ready (unsigned short  *Dst);


void SoftwareIDEntryCmd(unsigned short *FlashBaseAddr)
{            
	
	
	*(FlashBaseAddr+SWID_READ_ADDR1)=SWID_READ_CMD1;
	Delay(100);
	*(FlashBaseAddr+SWID_READ_ADDR2)=SWID_READ_CMD2;
	Delay(100);
	*(FlashBaseAddr+SWID_READ_ADDR3)=SWID_READ_CMD3;
	Delay(1000);
	
}
void SoftwareIDExitCmd(unsigned short *FlashBaseAddr)
{            
	
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR1)=SW_CFI_EXIT_CMD1;
		
	Delay(100);
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR2)=SW_CFI_EXIT_CMD2;
	Delay(100);
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR3)=SW_CFI_EXIT_CMD3;
	
	Delay(1000);
	
}
void EraseFlashSectorCmd(unsigned short *addr)
{
	unsigned short *FlashBaseAddr;
	unsigned short *FlashEraseAddr;

	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	FlashEraseAddr=(unsigned short *)addr;
	*(FlashBaseAddr+SEC_ERASE_ADDR1)=SEC_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR2)=SEC_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR3)=SEC_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR4)=SEC_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR5)=SEC_ERASE_CMD5;
	Delay(100);
	*FlashEraseAddr=SEC_ERASE_CMD6;
	Delay(1000);
}
void EraseFlashBlockCmd(unsigned short *addr)
{
	unsigned short *FlashBaseAddr;
	unsigned short *FlashEraseAddr;
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	FlashEraseAddr=(unsigned short *)addr;
	*(FlashBaseAddr+BLOCK_ERASE_ADDR1)=BLOCK_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR2)=BLOCK_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR3)=BLOCK_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR4)=BLOCK_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR5)=BLOCK_ERASE_CMD5;
	Delay(100);
	*FlashEraseAddr=BLOCK_ERASE_CMD6;
	Delay(1000);
}
void EraseFlashChipCmd(void)
{
	unsigned short *FlashBaseAddr;
	
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	
	*(FlashBaseAddr+CHIP_ERASE_ADDR1)=CHIP_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR2)=CHIP_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR3)=CHIP_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR4)=CHIP_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR5)=CHIP_ERASE_CMD5;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR6)=CHIP_ERASE_CMD6;
	
	Delay(1000);
}
void FlshProgramWrite(unsigned short *DestAddr,unsigned short *SrcAddr)
{
	unsigned short *FlashBaseAddr;
	//unsigned short *WriteAddr;
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	//WriteAddr = (unsigned short *)DestAddr;
	//console_printf("Write addr = 0x%X\n",DestAddr);
	//console_printf("Write src  = 0x%X\n",SrcAddr);
	//console_printf("Write value = 0x%X\n",*SrcAddr);
	*(FlashBaseAddr+WORD_PRG_ADDR1)=WORD_PRG_CMD1;
	Delay(100);
	*(FlashBaseAddr+WORD_PRG_ADDR2)=WORD_PRG_CMD2;
	Delay(100);
	*(FlashBaseAddr+WORD_PRG_ADDR3)=WORD_PRG_CMD3;
	*DestAddr = *SrcAddr;
	Check_Toggle_Ready(DestAddr);
	Delay(100);
	
/*	console_printf("Read value = 0x%X\n",*DestAddr);
	
	if(*WriteAddr  == *SrcAddr)
		console_printf("ok\n");
	else
		console_printf("error\n");	
*/
}
void Check_Toggle_Ready (unsigned short  *Dst)
{
        int Loop = TRUE;
        short PreData;
        short CurrData;
        unsigned long TimeOut = 0;

        PreData = *Dst;
        PreData = PreData & 0x4040;
        while ((TimeOut< 0x07FFFFFF) && (Loop))
        {
            CurrData = *Dst;
            CurrData = CurrData & 0x4040;
            if (PreData == CurrData)
                    Loop = FALSE;   /* ready to exit the while loop */
            PreData = CurrData;
            TimeOut++;
        }
}	
		     
int EraseOneFlashSector(unsigned short *addr)
{
		
	console_printf("Erase Sector at:0X%08X:",addr);
	
	if((int)addr%FLASH_SECTOR_SIZE){
		console_printf("error!\n");
		return FALSE;
		}
	EraseFlashSectorCmd(addr);
	console_printf("OK\n");
	
	return TRUE;
}

int EraseOneFlashBlock(unsigned short *addr)
{
		
	console_printf("Erase Block at:0X%08X:",addr);
	
	if((int)addr%FLASH_BLOCK_SIZE){
		console_printf("error!\n");
		return FALSE;
		}
	EraseFlashBlockCmd(addr);
	console_printf("OK\n");
	
	return TRUE;
}   
int EraseOneFlashChip(unsigned short *addr)
{
		
	console_printf("Erase Chip at:0X%08X:",addr);
	
	if((int)addr%FLASH_SIZE){
		console_printf("error!\n");
		return FALSE;
		}
	EraseFlashChipCmd();
	console_printf("OK\n");
	
	return TRUE;
}   

int EraseFlash(unsigned short *addr,int len)
{
	unsigned short *ptr;
	unsigned short *end;
	end=(unsigned short *)(addr+len/FBOUND);
	ptr=(unsigned short *)addr;
	for(ptr;ptr<end;ptr+= FLASH_SECTOR_SIZE/FBOUND)
	{
		console_printf("Erase Sector at:0X%08X.",ptr);
		
		if(!EraseOneFlashSector(ptr)){
			console_printf("\n");
			return FALSE;
		}
	}
	console_printf("\n");
	return TRUE;
}
int WriteToFlash(unsigned short *dest,unsigned short *src,int length)
{
	unsigned short *s1,*s2;
	int len,i;
	
	s1=(unsigned short *)dest;
	s2=(unsigned short *)src;
	
	if(((int)s1 & (FBOUND-1)) || ((int)s2 & (FBOUND-1))){
		console_printf("DestAddr or SrcAddr is not on a word boundary.\n");
		return FALSE;
	}
	
	if(length & (FBOUND-1)) length +=FBOUND;
	length &= ~((short)(FBOUND-1));
	len=length/FBOUND;
	for(i=0;i<len;i++,s1++,s2++){
		
		FlshProgramWrite(s1,s2);
		if(*s1 !=*s2){
			console_printf("Verify error\n");
			console_printf("Addr = 0x%08X\n",s1);
			console_printf("valid data = 0x%X\n",*s2);
			console_printf("error data =0x%X\n",*s1);
			return FALSE;
		}
			
		
	}
	return TRUE;
}
              
//int Flash_Code_Dig(COMMAND_BUFFER *command_desc)
//{       
//	
//	int DeviceID=0;
//	int ManufacturerID=0;
//	unsigned short *FlashBaseAddr;
//	
//	FlashBaseAddr=(unsigned short *)FLASH_BASE;
//	SoftwareIDEntryCmd(FlashBaseAddr);
//	
//	ManufacturerID = *(FlashBaseAddr + 0x00);
//	
//	DeviceID = *(FlashBaseAddr + 0x01);
//	
//	if((DeviceID==Flash_256KB) | (DeviceID==Flash_512KB)|(DeviceID==Flash_1M)){
//
//		if(DeviceID==Flash_256KB){
//			
//			console_printf("Flash Memory SST39LF/VF200A Detect\n");
//			console_printf("Device Code ID:%X\n",DeviceID);
//			
//		}
//		else if(DeviceID==Flash_512KB){
//			
//			console_printf("Flash Memory SST39LF/VF400A Detect\n");
//			console_printf("Device Code ID:%X\n",DeviceID);
//			
//		}
//		else if(DeviceID==Flash_1M){
//			
//			console_printf("Flash Memory SST39LF/VF800A Detect\n");
//			console_printf("Device Code ID:%X\n",DeviceID);
//			
//		}
//		else {
//		console_printf("Flash Memory Device ID Check error! \n");
//		console_printf("Device error Code  ID:0X%08X",DeviceID);
//		
//		}
//	console_printf("Flash Memory Manufacturers ID = %X\n",ManufacturerID);
//	
//	}
//	else {
//		console_printf("\nUndefined Flash Memory\n");
//		console_printf("Device  Code:%X",DeviceID);
//		console_printf("\nManufacture Code:%X",ManufacturerID);
//		
//	}
//	console_printf("\n");
//	SoftwareIDExitCmd(FlashBaseAddr);
//	return 1;
//}
//
//int Flash_Erase_Dig(COMMAND_BUFFER *command_desc)
//{
//	int StartAddr;
//        int	Len;
//        int	EndAddr;
//        char c;
//	
//	switch (command_desc->argc){
//		case 2:	
//			
//			
//			 if(AsciiToHex(command_desc,1,&StartAddr)){ 
//		 		console_printf("Flash One Block Eraser\n");
//				console_printf("Flash Address:0X%08X\n",StartAddr);
//				console_printf("Flash Erase sector unit -> 1\n");
//				console_printf("Flash Erase block  unit -> 2\n");
//				console_printf("Flash Erase Chip   unit -> 3\n");
//				c=Get_char();
//				switch(c){
//					case '1':console_printf("Flash Erase 4KB Sector Unit\n");
//						 return (EraseOneFlashSector((unsigned short *)StartAddr));
//						 break;
//					
//					case '2':console_printf("Flash Erase 64KB Block Unit\n");
//						 
//				  		 return (EraseOneFlashBlock((unsigned short *)StartAddr));
//				  		 break;
//					case '3':console_printf("Flash Erase Chip Unit\n");
//						
//				  		 return (EraseOneFlashChip((unsigned short *)StartAddr));
//				  		 break;
//					default	:break;				
//				}	
//	
//			}
//			else {
//			console_printf("---------------------------\n");
//			console_printf("ex)fe   {mon}\n");
//			console_printf("ex)fe   [addr]             \n");
//      			console_printf("ex)fe   [addr] [len]       \n");
//			console_printf("---------------------------\n");
//			return FALSE;
//			}
//			break;	
//		case 3:
//			if (AsciiToHex(command_desc,1,&StartAddr)||AsciiToHex(command_desc,2,&Len)){
//				
//				EndAddr=(unsigned long)(StartAddr+Len);
//				console_printf("Eraser Monitor Flash Block\n");
//				console_printf("Flash Address form 0X%08X to 0X%08X\n",StartAddr,EndAddr);
//				console_printf("Flash Erase sector unit -> 1\n");
//				console_printf("Flash Erase block  unit -> 2\n");
//				console_printf("Flash Erase Chip   unit -> 3\n");
//				c=Get_char();
//				switch(c){
//					case '1':console_printf("Flash Erase 4KB Sector Unit\n");
//						 for(;StartAddr<EndAddr;StartAddr+=FLASH_SECTOR_SIZE){
//				  		 if(!EraseOneFlashSector((unsigned short *)StartAddr)) 
//				  		 return FALSE;
//						}
//						break;
//					case '2':console_printf("Flash Erase 64KB Block Unit\n");
//						 for(;StartAddr<EndAddr;StartAddr+=FLASH_BLOCK_SIZE){
//				  		 if(!EraseOneFlashBlock((unsigned short *)StartAddr)) 
//				  		 return FALSE;
//						}
//						break;
//					case '3':console_printf("Flash Erase Chip Unit\n");
//						 if(!EraseOneFlashChip((unsigned short *)StartAddr)) 
//				  		 return FALSE;
//				  		 break;
//					default	:break;				
//				}	
//						
//				
//				
//				
//			}
//			else {
//			console_printf("---------------------------\n");
//			console_printf("ex)fe   {mon}\n");
//			console_printf("ex)fe   [addr]             \n");
//      			console_printf("ex)fe   [addr] [len]       \n");
//			console_printf("---------------------------\n");
//			return FALSE;
//			}
//			break;
//		default :
//			console_printf("---------------------------\n");
//			console_printf("ex)fe   {mon}\n");
//			console_printf("ex)fe   [addr]             \n");
//      			console_printf("ex)fe   [addr] [len]       \n");
//			console_printf("---------------------------\n");
//			return FALSE;
//			break;
//	}
//	return TRUE;
//
//}
//	
//int FlashWrite_Dig(COMMAND_BUFFER *command_desc)
//{
//	
//	int DestAddr=0;
//	int SrcAddr=0;
//	int EndAddr=0;
//	int Len;
//	int Sector=0;
//		
//		
//        		
//			if(!AsciiToHex(command_desc,1,&DestAddr) || 
//			   !AsciiToHex(command_desc,2,&SrcAddr) ||
// 			   !AsciiToHex(command_desc,3,&Len)){
//     			   
//				console_printf("-----------------------------------------\n");
//				
//      				console_printf("ex)fw   [DestAddr] [SrcAddr] [len]       \n");
//				console_printf("-----------------------------------------\n");
//			       return FALSE;
//			}
//			if(DestAddr%FLASH_SECTOR_SIZE){
//				console_printf("DestAddr is not Flash Block Base.\n");
//				return FALSE;
//			}
//			
//		
//
//		EndAddr=(DestAddr+Len-1);		
//		console_printf("Erase Flash Blocks From 0X%08X to 0X%08X\n",DestAddr,EndAddr);
//		
//		if(!EraseFlash((unsigned short *)DestAddr,Len)) 
//				return FALSE;
//		console_printf("Write to Flash....\n");
//		Sector=FLASH_SECTOR_SIZE;
//		while(Len>0){
//			ClearLine();
//			console_printf("Writing at 0X%08X....",DestAddr);
//			
//			if(Len > Sector){
//				if(!WriteToFlash((unsigned short *)DestAddr,(unsigned short *)SrcAddr,
//							Sector)) break;
//
//				DestAddr += Sector;
//				SrcAddr += Sector;
//				Len -= Sector;
//			}//if
//			else if(Len>0){
//				if(!WriteToFlash((unsigned short *)DestAddr,(unsigned short *)SrcAddr,Sector)) break;
//				console_printf("\n");
//				console_printf("Done....\n\n");
//				break;
//			}
//			else break;
//		}
//		return TRUE;
//}

