#include <stdio.h>
#include <string.h>
#include "flash_sst.h"
#include "config.h"



void Check_Toggle_Ready (unsigned short  *Dst);


void SoftwareIDEntryCmd(unsigned short *FlashBaseAddr)
{            
	
	
	*(FlashBaseAddr+SWID_READ_ADDR1)=SWID_READ_CMD1;
	Delay(100);
	*(FlashBaseAddr+SWID_READ_ADDR2)=SWID_READ_CMD2;
	Delay(100);
	*(FlashBaseAddr+SWID_READ_ADDR3)=SWID_READ_CMD3;
	Delay(1000);
	
}
void SoftwareIDExitCmd(unsigned short *FlashBaseAddr)
{            
	
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR1)=SW_CFI_EXIT_CMD1;
		
	Delay(100);
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR2)=SW_CFI_EXIT_CMD2;
	Delay(100);
	*(FlashBaseAddr+SW_CFI_EXIT_ADDR3)=SW_CFI_EXIT_CMD3;
	
	Delay(1000);
	
}
void EraseFlashSectorCmd(unsigned short *addr)
{
	unsigned short *FlashBaseAddr;
	unsigned short *FlashEraseAddr;

	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	FlashEraseAddr=(unsigned short *)addr;
	*(FlashBaseAddr+SEC_ERASE_ADDR1)=SEC_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR2)=SEC_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR3)=SEC_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR4)=SEC_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+SEC_ERASE_ADDR5)=SEC_ERASE_CMD5;
	Delay(100);
	*FlashEraseAddr=SEC_ERASE_CMD6;
	Delay(1000);
}
void EraseFlashBlockCmd(unsigned short *addr)
{
	unsigned short *FlashBaseAddr;
	unsigned short *FlashEraseAddr;
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	FlashEraseAddr=(unsigned short *)addr;
	*(FlashBaseAddr+BLOCK_ERASE_ADDR1)=BLOCK_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR2)=BLOCK_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR3)=BLOCK_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR4)=BLOCK_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+BLOCK_ERASE_ADDR5)=BLOCK_ERASE_CMD5;
	Delay(100);
	*FlashEraseAddr=BLOCK_ERASE_CMD6;
	Delay(1000);
}
void EraseFlashChipCmd(void)
{
	unsigned short *FlashBaseAddr;
	
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	
	*(FlashBaseAddr+CHIP_ERASE_ADDR1)=CHIP_ERASE_CMD1;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR2)=CHIP_ERASE_CMD2;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR3)=CHIP_ERASE_CMD3;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR4)=CHIP_ERASE_CMD4;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR5)=CHIP_ERASE_CMD5;
	Delay(100);
	*(FlashBaseAddr+CHIP_ERASE_ADDR6)=CHIP_ERASE_CMD6;
	
	Delay(1000);
}
void FlshProgramWrite(unsigned short *DestAddr,unsigned short *SrcAddr)
{
	unsigned short *FlashBaseAddr;
	//unsigned short *WriteAddr;
	FlashBaseAddr = (unsigned short *)FLASH_BASE;
	//WriteAddr = (unsigned short *)DestAddr;
	//Sprintf("Write addr = 0x%08X\n",DestAddr);
	//Sprintf("Write value = 0x%X\n",*SrcAddr);
	*(FlashBaseAddr+WORD_PRG_ADDR1)=WORD_PRG_CMD1;
	Delay(100);
	*(FlashBaseAddr+WORD_PRG_ADDR2)=WORD_PRG_CMD2;
	Delay(100);
	*(FlashBaseAddr+WORD_PRG_ADDR3)=WORD_PRG_CMD3;
	*DestAddr = *SrcAddr;
	Check_Toggle_Ready(DestAddr);
	Delay(100);
	
/*	Sprintf("Read value = 0x%X\n",*DestAddr);
	
	if(*WriteAddr  == *SrcAddr)
		Sprintf("ok\n");
	else
		Sprintf("error\n");	
*/
}
void Check_Toggle_Ready (unsigned short  *Dst)
{
        int Loop = TRUE;
        short PreData;
        short CurrData;
        unsigned long TimeOut = 0;

        PreData = *Dst;
        PreData = PreData & 0x4040;
        while ((TimeOut< 0x07FFFFFF) && (Loop))
        {
            CurrData = *Dst;
            CurrData = CurrData & 0x4040;
            if (PreData == CurrData)
                    Loop = FALSE;   /* ready to exit the while loop */
            PreData = CurrData;
            TimeOut++;
        }
}	
		     
int EraseOneFlashSector(unsigned short *addr)
{
		
	Sprintf("Erase Sector at:0X%08X:",addr);
	
	if((int)addr%FLASH_SECTOR_SIZE){
		Sprintf("error!\n");
		return FALSE;
		}
	EraseFlashSectorCmd(addr);
	Sprintf("OK\n");
	
	return TRUE;
}

int EraseOneFlashBlock(unsigned short *addr)
{
		
	Sprintf("Erase Block at:0X%08X:",addr);
	
	if((int)addr%FLASH_BLOCK_SIZE){
		Sprintf("error!\n");
		return FALSE;
		}
	EraseFlashBlockCmd(addr);
	Sprintf("OK\n");
	
	return TRUE;
}   
int EraseOneFlashChip(unsigned short *addr)
{
		
	Sprintf("Erase Chip at:0X%08X:",addr);
	
	if((int)addr%FLASH_SIZE){
		Sprintf("error!\n");
		return FALSE;
		}
	EraseFlashChipCmd();
	Sprintf("OK\n");
	
	return TRUE;
}   

int EraseFlash(unsigned short *addr,int len)
{
	unsigned short *ptr;
	unsigned short *end;
	end=(unsigned short *)(addr+len/FBOUND);
	ptr=(unsigned short *)addr;
	for(ptr;ptr<end;ptr+= FLASH_SECTOR_SIZE/FBOUND){
		ClearLine();
		Sprintf("Erase Sector at:0X%08X.",ptr);
		
		if(!EraseOneFlashSector(ptr)){
			Sprintf("\n");
			return FALSE;
		}
	}
	Sprintf("\n");
	return TRUE;
}
int WriteToFlash(unsigned short *dest,unsigned short *src,int length)
{
	unsigned short *s1,*s2;
	int len,i;
	
	s1=(unsigned short *)dest;
	s2=(unsigned short *)src;
	
	if(((int)s1 & (FBOUND-1)) || ((int)s2 & (FBOUND-1))){
		Sprintf("DestAddr or SrcAddr is not on a word boundary.\n");
		return FALSE;
	}
	
	if(length & (FBOUND-1)) length +=FBOUND;
	length &= ~((short)(FBOUND-1));
	len=length/FBOUND;
	for(i=0;i<len;i++,s1++,s2++){
		
		FlshProgramWrite(s1,s2);
		if(*s1 !=*s2){
			Sprintf("Verify error\n");
			Sprintf("Addr = 0x%08X\n",s1);
			Sprintf("valid data = 0x%X\n",*s2);
			Sprintf("error data =0x%X\n",*s1);
			return FALSE;
		}
			
		
	}
	return TRUE;
}
              
int Flash_Code_Dig(COMMAND_BUFFER *command_desc)
{       
	
	int DeviceID=0;
	int ManufacturerID=0;
	unsigned short *FlashBaseAddr;
	
	FlashBaseAddr=(unsigned short *)FLASH_BASE;
	SoftwareIDEntryCmd(FlashBaseAddr);
	
	ManufacturerID = *(FlashBaseAddr + 0x00);
	
	DeviceID = *(FlashBaseAddr + 0x01);
	
	if((DeviceID==Flash_256KB) | (DeviceID==Flash_512KB)|(DeviceID==Flash_1M)){

		if(DeviceID==Flash_256KB){
			
			Sprintf("Flash Memory SST39LF/VF200A Detect\n");
			Sprintf("Device Code ID:%X\n",DeviceID);
			
		}
		else if(DeviceID==Flash_512KB){
			
			Sprintf("Flash Memory SST39LF/VF400A Detect\n");
			Sprintf("Device Code ID:%X\n",DeviceID);
			
		}
		else if(DeviceID==Flash_1M){
			
			Sprintf("Flash Memory SST39LF/VF800A Detect\n");
			Sprintf("Device Code ID:%X\n",DeviceID);
			
		}
		else {
		Sprintf("Flash Memory Device ID Check error! \n");
		Sprintf("Device error Code  ID:0X%08X",DeviceID);
		
		}
	Sprintf("Flash Memory Manufacturers ID = %X\n",ManufacturerID);
	
	}
	else {
		Sprintf("\nUndefined Flash Memory\n");
		Sprintf("Device  Code:%X",DeviceID);
		Sprintf("\nManufacture Code:%X",ManufacturerID);
		
	}
	Sprintf("\n");
	SoftwareIDExitCmd(FlashBaseAddr);
	return 1;
}

int Flash_Erase_Dig(COMMAND_BUFFER *command_desc)
{
	int StartAddr;
        int	Len;
        int	EndAddr;
        char c;
	
	switch (command_desc->argc){
		case 2:	
			
			
			 if(AsciiToHex(command_desc,1,&StartAddr)){ 
		 		Sprintf("Flash One Block Eraser\n");
				Sprintf("Flash Address:0X%08X\n",StartAddr);
				Sprintf("Flash Erase sector unit -> 1\n");
				Sprintf("Flash Erase block  unit -> 2\n");
				Sprintf("Flash Erase Chip   unit -> 3\n");
				c=Get_char();
				switch(c){
					case '1':Sprintf("Flash Erase 4KB Sector Unit\n");
						 return (EraseOneFlashSector((unsigned short *)StartAddr));
						 break;
					
					case '2':Sprintf("Flash Erase 64KB Block Unit\n");
						 
				  		 return (EraseOneFlashBlock((unsigned short *)StartAddr));
				  		 break;
					case '3':Sprintf("Flash Erase Chip Unit\n");
						
				  		 return (EraseOneFlashChip((unsigned short *)StartAddr));
				  		 break;
					default	:break;				
				}	
	
			}
			else {
			Sprintf("---------------------------\n");
			Sprintf("ex)fe   {mon}\n");
			Sprintf("ex)fe   [addr]             \n");
      			Sprintf("ex)fe   [addr] [len]       \n");
			Sprintf("---------------------------\n");
			return FALSE;
			}
			break;	
		case 3:
			if (AsciiToHex(command_desc,1,&StartAddr)||AsciiToHex(command_desc,2,&Len)){
				
				EndAddr=(unsigned long)(StartAddr+Len);
				Sprintf("Eraser Monitor Flash Block\n");
				Sprintf("Flash Address form 0X%08X to 0X%08X\n",StartAddr,EndAddr);
				Sprintf("Flash Erase sector unit -> 1\n");
				Sprintf("Flash Erase block  unit -> 2\n");
				Sprintf("Flash Erase Chip   unit -> 3\n");
				c=Get_char();
				switch(c){
					case '1':Sprintf("Flash Erase 4KB Sector Unit\n");
						 for(;StartAddr<EndAddr;StartAddr+=FLASH_SECTOR_SIZE){
				  		 if(!EraseOneFlashSector((unsigned short *)StartAddr)) 
				  		 return FALSE;
						}
						break;
					case '2':Sprintf("Flash Erase 64KB Block Unit\n");
						 for(;StartAddr<EndAddr;StartAddr+=FLASH_BLOCK_SIZE){
				  		 if(!EraseOneFlashBlock((unsigned short *)StartAddr)) 
				  		 return FALSE;
						}
						break;
					case '3':Sprintf("Flash Erase Chip Unit\n");
						 if(!EraseOneFlashChip((unsigned short *)StartAddr)) 
				  		 return FALSE;
				  		 break;
					default	:break;				
				}	
						
				
				
				
			}
			else {
			Sprintf("---------------------------\n");
			Sprintf("ex)fe   {mon}\n");
			Sprintf("ex)fe   [addr]             \n");
      			Sprintf("ex)fe   [addr] [len]       \n");
			Sprintf("---------------------------\n");
			return FALSE;
			}
			break;
		default :
			Sprintf("---------------------------\n");
			Sprintf("ex)fe   {mon}\n");
			Sprintf("ex)fe   [addr]             \n");
      			Sprintf("ex)fe   [addr] [len]       \n");
			Sprintf("---------------------------\n");
			return FALSE;
			break;
	}
	return TRUE;

}
	
int FlashWrite_Dig(COMMAND_BUFFER *command_desc)
{
	
	int DestAddr=0;
	int SrcAddr=0;
	int EndAddr=0;
	int Len;
	int Sector=0;
		
		
        		
			if(!AsciiToHex(command_desc,1,&DestAddr) || 
			   !AsciiToHex(command_desc,2,&SrcAddr) ||
 			   !AsciiToHex(command_desc,3,&Len)){
     			   
				Sprintf("-----------------------------------------\n");
				
      				Sprintf("ex)fw   [DestAddr] [SrcAddr] [len]       \n");
				Sprintf("-----------------------------------------\n");
			       return FALSE;
			}
			if(DestAddr%FLASH_SECTOR_SIZE){
				Sprintf("DestAddr is not Flash Block Base.\n");
				return FALSE;
			}
			
		

		EndAddr=(DestAddr+Len-1);		
		Sprintf("Erase Flash Blocks From 0X%08X to 0X%08X\n",DestAddr,EndAddr);
		
		if(!EraseFlash((unsigned short *)DestAddr,Len)) 
				return FALSE;
		Sprintf("Write to Flash....\n");
		Sector=FLASH_SECTOR_SIZE;
		while(Len>0){
			ClearLine();
			Sprintf("Writing at 0X%08X....",DestAddr);
			
			if(Len > Sector){
				if(!WriteToFlash((unsigned short *)DestAddr,(unsigned short *)SrcAddr,
							Sector)) break;

				DestAddr += Sector;
				SrcAddr += Sector;
				Len -= Sector;
			}//if
			else if(Len>0){
				if(!WriteToFlash((unsigned short *)DestAddr,(unsigned short *)SrcAddr,Sector)) break;
				Sprintf("\n");
				Sprintf("Done....\n\n");
				break;
			}
			else break;
		}
		return TRUE;
}

