//-----------------------------------------------------------------------------
//! \addtogroup EBOOT
//! @{
//  All rights reserved ADENEO SAS 2005
//-----------------------------------------------------------------------------
//! \file		Utils.c
//! \brief		Helper's routines for the AT91SAM9261EK Bootloader
//!
//! \if subversion
//!   $URL: http://centaure/svn/interne-ce_bsp_at91sam9261ek/TAGS/V150-Nadia1-19-Sep-2006/SRC/BOOTLOADER/EBOOT/utils.c $
//!   $Author: jjhiblot $
//!   $Revision: 561 $
//!   $Date: 2006-07-24 15:12:49 +0200 (lun., 24 juil. 2006) $
//! \endif
//-----------------------------------------------------------------------------

#include <windows.h>
#include <oal_memory.h>
#include <Nkintr.h>
#include "loader.h"
#include "bsp_cfg.h"
#include "AT91SAM9261EK.h"
#include "AT91SAM926x.h"
#include "lib_AT91SAM926x.h"
#include "AT91SAM926x_interface.h"


//----------------------------------------------------------------------------
// \fn    AT91F_LowLevelInit
// \brief This function performs very low level HW initialization
//----------------------------------------------------------------------------
#define			JBOOT_CORE_FREQUENCY_MHZ	200
#define			JBOOT_DIVIDER				4
void AT91F_LowLevelInit()
{	    
    AT91PS_PMC			pPMC		= (AT91PS_PMC) OALPAtoVA((DWORD) AT91C_BASE_PMC, FALSE);

	//This is here only in order to report the SDRAM test. It must be however redone in OEMDebugInit() because g_pDBGU is reset to  after
	//The following line is important. The bootloader may crash if removed. We must set g_pDBGU to NULL prior to call OALPAtoVA because it may use the serial port
	AT91SAM926x_SetDebugSerialInterface(NULL);	
	AT91SAM926x_SetDebugSerialInterface((AT91PS_DBGU) OALPAtoVA((DWORD) AT91C_BASE_DBGU,FALSE));
	OEMInitDebugSerial();


	AT91SAM926x_SetProcessorAndMasterClocks(pPMC, JBOOT_CORE_FREQUENCY_MHZ, JBOOT_DIVIDER);

	// PLLB configuration : PLL B is running at 48 MHz and there's no further divider for the USBs	
	AT91SAM926x_SetPLLBFreq(pPMC, 48 , AT91C_CKGR_USBDIV_0);	

	OEMInitDebugSerial();
}

