#include <types.h>
#include <console.h>

#include <mach/SAMA5D3X.h>




EXTERN VOID do_console(VOID);

typedef enum {
	ram_failure,
	ram_ok
} ram_test_t;


EXTERN UINT32 ramtest(UINT32, UINT32);

STATIC UINT32	ram_size;
STATIC UINT32	ram_base;


STATIC ram_test_t ram_test(VOID)
{
	UINT32 ptr;
	ram_test_t ret = ram_ok;

	console_printf("       KB SDRAM OK");

	for (ptr = 0; ptr < ram_size; ptr+=4)//ptr += 512) 
    {
		if (ramtest(ram_base+ptr, 0x55aacc33) != 0x55aacc33)
        {
			console_printf("\nMemory error detected at address 0x%08X\n", ptr);
			ret = ram_failure;
			break;
		}
		if ((ptr & 524280) == 0)
			console_printf("\r%6x", ptr >> 10);
	}

	if (ret == ram_ok)
		console_printf("\r%6x\n", ram_size >> 10);

	return ret;
}

//
//STATIC VOID panic(BYTE *s)
//{
//	if (s)
//		console_printf("%s", s);
//	console_printf(" -- System Halted");
//	while(1);
//}
//
//
//
//#define PLL_FREQUENCY_RANGE_LIMIT   195000000
//
//
//#define DEFAULT_BUS_RATIO	4
//#define MAX_PRESCALER		6
//
//#define PLL_OUT_RANGE_MIN	80
//
//
//STATIC VOID
//ComputeMulAndDiv(UINT32 dwSrcFreqInHz, UINT32 dwDestFreqInHz, UINT32 *pMul, UINT32 *pDiv)
//{
//	UINT32 dwMul,dwDiv;
//	UINT32 dwDestFreqInKHz = dwDestFreqInHz / 1000;
//	UINT32 dwSrcFreqInKHz = dwSrcFreqInHz / 1000;
//	
//	dwDiv = 255 * 2;	
//	do
//	{
//		dwDiv /= 2;
//		dwMul = (dwDestFreqInKHz * dwDiv) / dwSrcFreqInKHz;
//		
//	} while (dwMul > 2048);
//	
//	*pMul = dwMul;
//	*pDiv = dwDiv;
//
//    return;
//}
//
//
//
//STATIC UINT32 
//GetMainClockFreq(AT91PS_PMC pPMC)
//{
//	if (pPMC->PMC_MCFR & AT91C_CKGR_MAINRDY)
//	{		
//		return ((pPMC->PMC_MCFR & AT91C_CKGR_MAINF) * (SLOW_CLOCK_FREQUENCY)) / 16;
//	}
//	else
//	{
//		return 0;
//	}
//}
//
//STATIC UINT32
//AT91SAM926x_SetPLLBFreq( AT91PS_PMC pPMC, UINT32 dwFreqInMHz, UINT32 dwUSBDivider)
//{
//
//    UINT32 dwTemp = 0;
//    UINT32 dwFreq,dwMainClock;  	
//	UINT32 dwDiv;
//	UINT32 dwMul;
//
//	//console_printf("AT91SAM926x_SetPLLBFreq is %d MHz\r\n",dwFreqInMHz);
//	
//	dwMainClock = GetMainClockFreq(pPMC);
//	ComputeMulAndDiv(dwMainClock,dwFreqInMHz * 1000000,&dwMul,&dwDiv);
//        
//    dwTemp |= (dwMul << 16) | (dwDiv);    
//    dwTemp |= dwUSBDivider;
//        
//        
//    dwFreq = (dwMainClock / dwDiv) * (dwMul+1);    
//    if (dwFreq < PLL_FREQUENCY_RANGE_LIMIT)
//    {
//        dwTemp |= AT91C_CKGR_OUTB_0;
//    }
//    else
//    {
//        dwTemp |= AT91C_CKGR_OUTB_2;
//    }
//    
//    dwTemp |= (AT91C_CKGR_PLLBCOUNT & (0x3FF << 8)); //Maximum setup time (we don't really know the characteristics of the PLL filter implemented on the board).
//    
//    
//    pPMC->PMC_PLLBR = dwTemp;
//    
//    while ((pPMC->PMC_SR & AT91C_PMC_LOCKB) == 0);    
//    
//    return 0;
//
//}
//
//#define DELAY() {volatile int i ; for(i=0;i<0xFFFF;i++);}
//
//
//STATIC BOOL
//AT91SAM926x_SetProcessorAndMasterClocks( AT91PS_PMC pPMC, UINT32 dwProcessorClockInMHz, UINT32 dwBusClockRatio )
//{
//	UINT32 PLLA_CountBeforeStable;
//	UINT32 PLLA_Divider;
//	UINT32 PLLA_Multipler;
//	UINT32 PLLA_BusRatio;
//	UINT32 dwTemp;
//	UINT32 dwPrescaler = 0;
//	
//	UINT32 dwTargetPLLFrequencyInMHz = dwProcessorClockInMHz;
//
////	console_printf("Target processor Frequency is %d\r\n", dwProcessorClockInMHz );
////	console_printf("Target Bus Frequency is %d\r\n", dwProcessorClockInMHz/dwBusClockRatio );
//
//	/* Compute the prescaler if needed */
//	while (dwTargetPLLFrequencyInMHz < PLL_OUT_RANGE_MIN)
//	{
//		dwPrescaler++;
//		if (dwPrescaler > MAX_PRESCALER)
//		{
//			return FALSE;
//		}
//		dwTargetPLLFrequencyInMHz = dwProcessorClockInMHz * (1 << dwPrescaler);
//	}
//
//	// Clip the selected bus ratio
//	if ((dwBusClockRatio != 1) && (dwBusClockRatio != 2) && (dwBusClockRatio != 4))
//	{
//		console_printf("AT91SAM926x_SetProcessorAndMasterClocks : Invalid bus ratio (%d). Setting default (%d)\r\n",dwBusClockRatio,DEFAULT_BUS_RATIO);
//		dwBusClockRatio = 4;
//	}
//
//
//	PLLA_CountBeforeStable	= 0x100;	
//	PLLA_BusRatio			= 0;
//
////	console_printf("2 Prescaler is %d\r\n",dwPrescaler);
////DELAY();
////	console_printf("Target PLL A Frequency is %d MHz\r\n",dwTargetPLLFrequencyInMHz);
////DELAY();
//	{
//		// Small tempo to let the Chip a bit time to settle.
//		// Someow it's no good to write characters on the serial before a bit.
//		volatile UINT32 dwTempo = 10000;
//		while (dwTempo--);
//	}
//
//	ComputeMulAndDiv(GetMainClockFreq(pPMC), dwTargetPLLFrequencyInMHz*1000000, &PLLA_Multipler, &PLLA_Divider);	
//	//DEBUGMSG(1,(TEXT("PLLA_Divider %d PLLA_Multipler %d"),PLLA_Divider,PLLA_Multipler));
//
//#if 0
//console_printf("switch master clock \r\n");
//	// Switch MasterClock To SlowClock, with a prescaler of 1 and a bus divider of 2
//    pPMC->PMC_MCKR = AT91C_PMC_MDIV_2 | AT91C_PMC_PRES_CLK | AT91C_PMC_CSS_SLOW_CLK;
//
////console_printf("Master CLock ready\r\n");
//	// Waiting that MasterClock is stable
//   	while ((pPMC->PMC_SR & AT91C_PMC_MCKRDY) == 0);
//
//#else
//
////console_printf("switch master clock \r\n");
//	// Switch MasterClock To SlowClock, with a prescaler of 1 and a bus divider of 2
//    pPMC->PMC_MCKR = AT91C_PMC_MDIV_2 | AT91C_PMC_CSS_SLOW_CLK;
//   	while ((pPMC->PMC_SR & AT91C_PMC_MCKRDY) == 0);
//
//    pPMC->PMC_MCKR = AT91C_PMC_MDIV_2 | AT91C_PMC_PRES_CLK | AT91C_PMC_CSS_SLOW_CLK;
//   	while ((pPMC->PMC_SR & AT91C_PMC_MCKRDY) == 0);
//
//#endif
//	// PLLA Configuration
//	dwTemp = AT91C_CKGR_SRCA | (PLLA_Multipler<<16) | (PLLA_CountBeforeStable<<8) | PLLA_Divider;
//
//	if ((dwTargetPLLFrequencyInMHz*1000000) < PLL_FREQUENCY_RANGE_LIMIT)
//    {
//        dwTemp |= AT91C_CKGR_OUTA_0;
//    }
//    else
//    {
//        dwTemp |= AT91C_CKGR_OUTA_2;
//    }
//
//	pPMC->PMC_PLLAR = dwTemp;
//	
////console_printf("PLLA ready\r\n");
//	// Waiting for PLLA to be stable
//	while ((pPMC->PMC_SR & AT91C_PMC_LOCKA) == 0); 
//
//	// Selecting the right Bus Ratio
//	switch (dwBusClockRatio)
//	{
//		case 1:
//			PLLA_BusRatio = AT91C_PMC_MDIV_1;
//			break;
//		case 2:
//			PLLA_BusRatio = AT91C_PMC_MDIV_2;
//			break;
//		case 4:
//			PLLA_BusRatio = AT91C_PMC_MDIV_3;
//			break;
//		default:
//			PLLA_BusRatio = AT91C_PMC_MDIV_3;
//	}
//
//	// Switch MasterClock to PLLA
//	pPMC->PMC_MCKR = PLLA_BusRatio | AT91C_PMC_CSS_PLLA_CLK | (dwPrescaler << 2);
//
////console_printf("MasterClock LOCK ready\r\n");
//	// Waiting fo MasterClock to be locked
//	while ((pPMC->PMC_SR & AT91C_PMC_MCKRDY) == 0);
//
////console_printf("AT91SAM926x_SetProcessorAndMasterClocks END\r\n");
//
//    return TRUE;
//
//}
//
//
//#define			JBOOT_CORE_FREQUENCY_MHZ	200
//#define			JBOOT_DIVIDER				4

EXTERN BOOL LLD_Init(VOID);

/*
 * This is the main entry point for the BIOS.
 */
VOID start_main(VOID)
{
	INT32 i;


//    AT91PS_PMC  pPMC = (AT91PS_PMC)AT91C_BASE_PMC;
//
//
////	//This is here only in order to report the SDRAM test. It must be however redone in OEMDebugInit() because g_pDBGU is reset to  after
////	//The following line is important. The bootloader may crash if removed. We must set g_pDBGU to NULL prior to call OALPAtoVA because it may use the serial port
////	AT91SAM926x_SetDebugSerialInterface(NULL);	
////	AT91SAM926x_SetDebugSerialInterface((AT91PS_DBGU) OALPAtoVA((UINT32) AT91C_BASE_DBGU,FALSE));
////	OEMInitDebugSerial();
//
//
//	AT91SAM926x_SetProcessorAndMasterClocks(pPMC, JBOOT_CORE_FREQUENCY_MHZ, JBOOT_DIVIDER);
//
//	// PLLB configuration : PLL B is running at 48 MHz and there's no further divider for the USBs	
//	AT91SAM926x_SetPLLBFreq(pPMC, 48 , AT91C_CKGR_USBDIV_0);	
//
//
//	ConsoleInit();	/* Initialise serial debug	*/
//
#if 0
	/* Check integrity of RAM */
    ram_base = 0x70000000;
    ram_size = 0x02000000;
	if (ram_test() == ram_failure)
		console_printf("ram failure");
#endif

	//Init flash
	//AT91F_NandFlash_Init(); 

    //	console_printf("init data flash\n");
	init_dataflash();

    //	console_printf("init display\n");
    DisplayInit();
	

#if 0
	for(i=0;i < 50;i++)
		ser_putch('=');

	ser_putch('\r');	
	ser_putch('\n');	

	for(i=0;i < 50;i++)
		ser_putch('=');

	ser_putch('\r');	
	ser_putch('\n');	

	console_printf("BIOS for Bootloader  v 0.2 : i-BOSN systems \n\n");

	console_printf("\t Enter to Consol Mode\n\n");
#else
	console_printf("ibosn systems : sama5d3x cpu-module\n");
#endif

//#define FOR_USER_TYPE
#ifdef FOR_USER_TYPE
    LCDD_PowerOn();
	do_console();
#else
    rdownload();
    {
        typedef VOID (*JUMPFUNC)( VOID);
        extern UINT32 platform_start;

    	UINT32	dwAddr;
    	JUMPFUNC    jumpfunc;
    	dwAddr = platform_start + 8;
    	dwAddr = ((UINT32)dwAddr & ~0x3);
    	jumpfunc = (JUMPFUNC)dwAddr;

        console_printf("Now Start : 0x%x\n", dwAddr);
    	jumpfunc();	
    }

#endif

	while (1);
}
