#include <types.h>
#include <console.h>

#include <macros.h>

extern CHAR *__PULL();
extern INT32	E_ston;

EXTERN INT32 ston(CHAR *s);
EXTERN BYTE CLIBisprintable(BYTE ch);

void delay(int i)
{
    int j;
    for( j = 0; j < i ; j++ );
}

VOID print_version(VOID)
{
	console_printf(" BootLoader -- version : 0.2\n");
}

VOID memorydump(VOID) 
{
	CHAR	*token ;
	UINT32	*dwAddr,*dwEnd;
	UINT32	dwLength;
	
	/*
	 *  Get all the arguments.
	 */
	/* start address supplied? */
	token = __PULL() ;
	if (token == NULL)
	{
		console_printf("\nERROR: you must supply a start address.\n") ;
		return ;
	}
	dwAddr = (UINT32 *)ston(token);
	if( E_ston )
	{
		console_printf("\nwrong parameter.\n") ;
		return;
	}
	
	token = __PULL() ;
	if ((token == NULL))
	{
		dwLength=0x100;
	} else {
		dwLength = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}
		
	}
	
	/* Align */
	dwAddr = (UINT32 *)(((UINT32)dwAddr) & ~0x3);
	dwLength = (dwLength + 15) & ~0xF;
	
	for (dwEnd = dwAddr + dwLength/4; dwAddr < dwEnd;) 
	{
		INT32 i;
		
		console_printf("%8.8X : ",(UINT32)dwAddr);

		console_printf("%8.8X ",(UINT32)*dwAddr);
		console_printf("%8.8X ",(UINT32)*(dwAddr+1));
		console_printf("%8.8X ",(UINT32)*(dwAddr+2));
		console_printf("%8.8X ",(UINT32)*(dwAddr+3));

		for (i=0;i<4;i++)
		{
			UINT32	data;

			data = *(volatile UINT32 *)dwAddr++ ;
			console_printf("%c%c%c%c", \
				CLIBisprintable((BYTE)(data&0xFF)),\
				CLIBisprintable((BYTE)((data>>8)&0xFF)),\
				CLIBisprintable((BYTE)((data>>16)&0xFF)),\
				CLIBisprintable((BYTE)((data>>24)&0xFF)) \
				);
		}
		
		console_printf("\n");
	}
}


VOID memorymodify(VOID) 
{
	CHAR	*token ;
	UINT32	*dwAddr;
	UINT32	dwData;
	
	/*
	 *  Get all the arguments.
	 */
	/* start address supplied? */
	token = __PULL() ;
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an address\n") ;
		return ;
	}

	dwAddr = (UINT32 *)ston(token);
	if( E_ston )
	{
		console_printf("\nwrong parameter.\n") ;
		return;
	}

	dwAddr = (UINT32 *)((UINT32)dwAddr & ~0x3);

	token = __PULL() ;
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply a data\n") ;
		return ;
	}
	dwData = ston(token);
	if( E_ston )
	{
		console_printf("\nwrong parameter.\n") ;
		return;
	}
	
	
	console_printf("%8.8X : %8.8X --> ", (UINT32)dwAddr, (UINT32)*dwAddr);
	console_printf("%8.8X\n",(UINT32)dwData);
	
	*dwAddr = dwData;
	
	return;	
}


#ifdef USE_FLASH_NOR

/*
 *******************************************************************
 * Flash Operation
 *******************************************************************
 */
#define FLASH_BASE_ADDR	(0x00000000)
#define	STRATA_BLOCK_SIZE	(0x20000)
#define	STRATA_BLOCK_SIZE_32	(0x40000)

#define AMIC_SECTOR_SIZE        (0x1000)

#define	STRATA_CMD_CLEAR_GSTATUS	0x5050
#define	STRATA_CMD_READ_GSTATUS		0x7070
#define	STRATA_CMD_WRITE_WORD		0x4040	// Tell flash to program
#define	STRATA_CMD_READ_ARRAY		0xFFFF	// Read(normal) mode
#define	STRATA_CMD_BLOCK_ERASE1		0x2020	// Start erase
#define	STRATA_CMD_BLOCK_ERASE2		0xD0D0	// Confirm erase
#define	STRATA_SR_READY			0x0080	// Ready for use status

#define	STRATA_CMD_CLEAR_GSTATUS_32	0x50505050
#define	STRATA_CMD_READ_GSTATUS_32	0x70707070
#define	STRATA_CMD_WRITE_WORD_32	0x40404040	// Tell flash to program
#define	STRATA_CMD_READ_ARRAY_32	0xFFFFFFFF	// Read(normal) mode
#define	STRATA_CMD_BLOCK_ERASE1_32	0x20202020	// Start erase
#define	STRATA_CMD_BLOCK_ERASE2_32	0xD0D0D0D0	// Confirm erase
#define	STRATA_SR_READY_32		0x00800080	// Ready for use status

#define STRATA_CMD_READ_IDENTIFIER	0x9090
#define STRATA_CMD_LOCK_0		0x6060
#define STRATA_CMD_LOCK_1		0x0101
#define STRATA_CMD_UNLOCK_0		0x6060
#define STRATA_CMD_UNLOCK_1		0xD0D0

#define STRATA_CMD_READ_IDENTIFIER_32	0x90909090
#define STRATA_CMD_LOCK_0_32		0x60606060
#define STRATA_CMD_LOCK_1_32		0x01010101
#define STRATA_CMD_UNLOCK_0_32		0x60606060
#define STRATA_CMD_UNLOCK_1_32		0xD0D0D0D0

#define	FLASH_CLEAR_GSTATUS(dwBlockAddr)	WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_CLEAR_GSTATUS)
#define	FLASH_READ_GSTATUS(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_READ_GSTATUS)
#define	FLASH_WRITE_WORD(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_WRITE_WORD)
#define	FLASH_READ_ARRAY(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_READ_ARRAY)
#define	FLASH_BLOCK_ERASE1(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_BLOCK_ERASE1)
#define	FLASH_BLOCK_ERASE2(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_BLOCK_ERASE2)
#define	FLASH_SR_READY(dwBlockAddr)		READ_REGISTER_USHORT(dwBlockAddr)

#define	FLASH_CLEAR_GSTATUS_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_CLEAR_GSTATUS_32)
#define	FLASH_READ_GSTATUS_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_READ_GSTATUS_32)
#define	FLASH_WRITE_WORD_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_WRITE_WORD_32)
#define	FLASH_READ_ARRAY_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_READ_ARRAY_32)
#define	FLASH_BLOCK_ERASE1_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_BLOCK_ERASE1_32)
#define	FLASH_BLOCK_ERASE2_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_BLOCK_ERASE2_32)
#define	FLASH_SR_READY_32(dwBlockAddr)		READ_REGISTER_ULONG(dwBlockAddr)

#define	FLASH_READ_IDENTIFIER(dwBlockAddr)	WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_READ_IDENTIFIER)
#define	FLASH_LOCK_0(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_LOCK_0)
#define	FLASH_LOCK_1(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_LOCK_1)
#define	FLASH_UNLOCK_0(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_UNLOCK_0)
#define	FLASH_UNLOCK_1(dwBlockAddr)		WRITE_REGISTER_USHORT(dwBlockAddr,(UINT16)STRATA_CMD_UNLOCK_1)

#define	FLASH_READ_IDENTIFIER_32(dwBlockAddr)	WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_READ_IDENTIFIER_32)
#define	FLASH_LOCK_0_32(dwBlockAddr)		WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_LOCK_0_32)
#define	FLASH_LOCK_1_32(dwBlockAddr)		WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_LOCK_1_32)
#define	FLASH_UNLOCK_0_32(dwBlockAddr)		WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_UNLOCK_0_32)
#define	FLASH_UNLOCK_1_32(dwBlockAddr)		WRITE_REGISTER_ULONG(dwBlockAddr,(UINT32)STRATA_CMD_UNLOCK_1_32)


//#define SM_FLASH_BASE_ADDR  (0x70000000)
//#define	SM_BLOCK_SIZE       (0x10000)
//#define	SM_BLOCK_SIZE_32	(0x20000)
//
//#define SM_DAT_RESET        0xF0
//
//#define SM_CMD_PROG0        0x0555
//#define SM_DAT_PROG0        0x00AA
//#define SM_CMD_PROG1        0x02AA
//#define SM_DAT_PROG1        0x0055
//#define SM_CMD_PROG2        0x0555
//#define SM_DAT_PROG2        0x00A0
//
//#define SM_CMD_CHPERASE0    0x0555
//#define SM_DAT_CHPERASE0    0x00AA
//#define SM_CMD_CHPERASE1    0x02AA
//#define SM_DAT_CHPERASE1    0x0055
//#define SM_CMD_CHPERASE2    0x0555
//#define SM_DAT_CHPERASE2    0x0080
//#define SM_CMD_CHPERASE3    0x0555
//#define SM_DAT_CHPERASE3    0x00AA
//#define SM_CMD_CHPERASE4    0x02AA
//#define SM_DAT_CHPERASE4    0x0055
//#define SM_CMD_CHPERASE5    0x0555
//#define SM_DAT_CHPERASE5    0x0010
//
//#define SM_CMD_SECERASE0    0x0555
//#define SM_DAT_SECERASE0    0x00AA
//#define SM_CMD_SECERASE1    0x02AA
//#define SM_DAT_SECERASE1    0x0055
//#define SM_CMD_SECERASE2    0x0555
//#define SM_DAT_SECERASE2    0x0080
//#define SM_CMD_SECERASE3    0x0555
//#define SM_DAT_SECERASE3    0x00AA
//#define SM_CMD_SECERASE4    0x02AA
//#define SM_DAT_SECERASE4    0x0055
//#define SM_CMD_SECERASE5    0x0000
//#define SM_DAT_SECERASE5    0x0030
//

//=================================== 32 nc ==========================================

static UINT32 flash_check_status_32( UINT32 dwBlockAddr)
{
	UINT32 iTimeOut = 0;
	
	while ( (FLASH_SR_READY_32(dwBlockAddr))!=STRATA_SR_READY_32 )
	{
		iTimeOut++;
		if( iTimeOut > 0xFFFFF)
		{
			console_printf("\n Timed out.\n");
			return FALSE;
		}	
	}
	
	return TRUE;
}

static UINT32 flash_erase_block_32(INT32 iBlock) //ULONG FlashEraseIBlock(ULONG dwBlock)
{
	UINT32	dwBlockAddr;

	console_printf(" %d :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 18);	// 256K / Block

	FLASH_CLEAR_GSTATUS_32(dwBlockAddr);

	// Get Global Status
	FLASH_READ_GSTATUS_32(dwBlockAddr);

	if( !flash_check_status_32(dwBlockAddr) )
		return 0;

	// Attempt to Erase the Block
	FLASH_BLOCK_ERASE1_32(dwBlockAddr);
	FLASH_BLOCK_ERASE2_32(dwBlockAddr);

	if( !flash_check_status_32(dwBlockAddr) )
		return 0;

	FLASH_READ_ARRAY_32(dwBlockAddr);	// Set Back to read array mode

//	if( !flash_check_status(dwBlockAddr) )
//		return 0;

	console_printf(" is erased.\n" );

	return 0;

}

static UINT32 flash_lock_block_32( INT32 iBlock)
{
	UINT32	dwBlockAddr;

	console_printf(" %d :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 18);	// 256K / Block

	FLASH_CLEAR_GSTATUS_32(dwBlockAddr);

	FLASH_LOCK_0_32(dwBlockAddr);
	FLASH_LOCK_1_32(dwBlockAddr);
	if( !flash_check_status_32(dwBlockAddr) )
		return 0;
	
	FLASH_READ_ARRAY_32(dwBlockAddr);	// Set Back to read array mode

	console_printf(" is locked.\n" );
	
	return 0;
}

static UINT32 flash_unlock_block_32( INT32 iBlock)
{
	UINT32	dwBlockAddr;

	console_printf(" %d :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 18);	// 256K / Block

	FLASH_CLEAR_GSTATUS_32(dwBlockAddr);

	FLASH_UNLOCK_0_32(dwBlockAddr);
	FLASH_UNLOCK_1_32(dwBlockAddr);
	if( !flash_check_status_32(dwBlockAddr) )
		return 0;
	
	FLASH_READ_ARRAY_32(dwBlockAddr);	// Set Back to read array mode
	
	console_printf(" is unlocked.\n" );

	return 0;
}

static UINT32 flash_program_block_32(UINT32 iBlock, CHAR *pData) 
{
	UINT32	dwBlockAddr;
	INT32 i;

    console_printf("pData = %x\n",(UINT32)pData);
	console_printf(" %d :",iBlock);

	// should be erased
	flash_erase_block_32(iBlock);
	
	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 18);	// 256K / Block
    console_printf("dwBlockAddr = %x\n",(UINT32)dwBlockAddr);

	FLASH_CLEAR_GSTATUS_32(dwBlockAddr);

	// Get Global Status
	FLASH_READ_GSTATUS_32(dwBlockAddr);

	if( !flash_check_status_32(dwBlockAddr) )
		return 0;


	for( i = 0; i < STRATA_BLOCK_SIZE_32; i+=4)
	{
		FLASH_WRITE_WORD_32(dwBlockAddr+i);						// Tell Flash to program..
		WRITE_REGISTER_ULONG(dwBlockAddr+i,*(UINT32*)(pData+i));					// Copy it to Flash
		if( !flash_check_status_32(dwBlockAddr+i) )
			return 0;
	}

	FLASH_READ_ARRAY_32(dwBlockAddr);	// Set Back to read array mode


	console_printf(" is programed.\n" );

	return 0;

}

UINT32 flash_lock_32( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_lock_block_32(iStart);

	return 0;
}
UINT32 flash_unlock_32( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_unlock_block_32(iStart);

	return 0;
}
	
UINT32 flash_erase_32( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_erase_block_32(iStart);

	return 0;
}

UINT32 flash_program_32( UINT32 iTarget, UINT32 iSource, UINT32 iSize)
{
	UINT32 iStart, iEnd;
	
	if( iTarget + iSize > 0x2000000)	//16M Flash 
	{
		console_printf("The paramenter is wrong\n");
		return 1;
	}
	
	iStart = (iTarget / STRATA_BLOCK_SIZE_32);
	iEnd = (iTarget + iSize + STRATA_BLOCK_SIZE_32-1)/STRATA_BLOCK_SIZE_32;

	for( ; iStart < iEnd; iStart++, iSource += STRATA_BLOCK_SIZE_32)
		flash_program_block_32(iStart, (CHAR *)iSource);

	return 0;
}


//====================================== 16 nc ==========================================

#if 0


static UINT32 flash_check_status( UINT32 dwBlockAddr)
{
	UINT32 iTimeOut = 0;
	
	while ( (FLASH_SR_READY(dwBlockAddr))!=STRATA_SR_READY )
	{
		iTimeOut++;
		if( iTimeOut > 0xFFFFF)
		{
			console_printf("\n Timed out.\n");
			return FALSE;
		}	
	}
	
	return TRUE;
}

static UINT32 flash_erase_block(INT32 iBlock) //ULONG FlashEraseIBlock(ULONG dwBlock)
{
	UINT32	dwBlockAddr;

RETRY_ERASE:
	console_printf(" %D :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block

	FLASH_CLEAR_GSTATUS(dwBlockAddr);

	// Get Global Status
	FLASH_READ_GSTATUS(dwBlockAddr);

	if( !flash_check_status(dwBlockAddr) )
	{
		console_printf(" status read fail : retry ");
		goto RETRY_ERASE;
		return 0;
	}

	// Attempt to Erase the Block
	FLASH_BLOCK_ERASE1(dwBlockAddr);
	FLASH_BLOCK_ERASE2(dwBlockAddr);

	if( !flash_check_status(dwBlockAddr) )
	{
		console_printf(" erase fail : retry ");
		goto RETRY_ERASE;
		return 0;
	}

	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode

//	if( !flash_check_status(dwBlockAddr) )
//		return 0;

	console_printf(" is erased.\n" );

	return 0;

}

static UINT32 flash_lock_block( INT32 iBlock)
{
	UINT32	dwBlockAddr;

	console_printf(" %d :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block

	FLASH_CLEAR_GSTATUS(dwBlockAddr);

	FLASH_LOCK_0(dwBlockAddr);
	FLASH_LOCK_1(dwBlockAddr);
	if( !flash_check_status(dwBlockAddr) )
		return 0;
	
	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode

	console_printf(" is locked.\n" );
	
	return 0;
}

static UINT32 flash_unlock_block( INT32 iBlock)
{
	UINT32	dwBlockAddr;

	console_printf(" %D :",iBlock);

	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block

	FLASH_CLEAR_GSTATUS(dwBlockAddr);

	FLASH_UNLOCK_0(dwBlockAddr);
	FLASH_UNLOCK_1(dwBlockAddr);
	if( !flash_check_status(dwBlockAddr) )
		return 0;
	
	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode
	
	console_printf(" is unlocked.\n" );

	return 0;
}

static UINT32 flash_program_block(UINT32 iBlock, CHAR *pData) 
{
	UINT32	dwBlockAddr;
	INT32 i;

    console_printf("pData = %X\n",(UINT32)pData);
RETRY_PROGRAM:
	console_printf(" %D :",iBlock);

	// should be erased
	flash_erase_block(iBlock);
	
	dwBlockAddr  =  FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block
    console_printf("dwBlockAddr = %X\n",(UINT32)dwBlockAddr);

	FLASH_CLEAR_GSTATUS(dwBlockAddr);

	// Get Global Status
	FLASH_READ_GSTATUS(dwBlockAddr);

	if( !flash_check_status(dwBlockAddr) )
	{
	    console_printf("status read fail : retry ");
	    goto RETRY_PROGRAM;
		return 0;
    }

	for( i = 0; i < STRATA_BLOCK_SIZE; i+=2)
	{
		FLASH_WRITE_WORD(dwBlockAddr+i);						// Tell Flash to program..
		WRITE_REGISTER_USHORT(dwBlockAddr+i,*(UINT16*)(pData+i));					// Copy it to Flash
		if( !flash_check_status(dwBlockAddr+i) )
    	{
    	    console_printf("program fail : retry ");
    	    goto RETRY_PROGRAM;
    		return 0;
        }
	}

	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode

	for( i = 0; i < STRATA_BLOCK_SIZE; i+=2)
	{
        if( *(PUINT16)(pData+i) != *(PUINT16)(dwBlockAddr + i) )
        {
    	    console_printf("program fail : retry ");
    	    goto RETRY_PROGRAM;
    		return 0;
        }
    }

	console_printf(" is programed.\n" );

	return 0;

}
UINT32 flash_lock( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_lock_block(iStart);

	return 0;
}
UINT32 flash_unlock( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_unlock_block(iStart);

	return 0;
}
	
UINT32 flash_erase( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_erase_block(iStart);

	return 0;
}

UINT32 flash_program( UINT32 iTarget, UINT32 iSource, UINT32 iSize)
{
	UINT32 iStart, iEnd;
	
	if( iTarget + iSize > 0x1000000)	//16M Flash 
	{
		console_printf("The paramenter is wrong\n");
		return 1;
	}
	
	iStart = (iTarget / STRATA_BLOCK_SIZE);
	iEnd = (iTarget + iSize + STRATA_BLOCK_SIZE-1)/STRATA_BLOCK_SIZE;

	for( ; iStart < iEnd; iStart++, iSource += STRATA_BLOCK_SIZE)
		flash_program_block(iStart, (CHAR *)iSource);

	return 0;
}

#else
#define SM_FLASH_BASE_ADDR          (0x00000000)
#define SM_FLASH_TOP_ADDR           (0x001F0000)
#define	SM_BLOCK_SIZE               (0x10000)
#define SM_BLOCK_SHIFT_BIT          (16)

#define SM_DAT_RESET                0x00F0

#define SM_CMD_PROG0                0x0555
#define SM_DAT_PROG0                0x00AA
#define SM_CMD_PROG1                0x0AAA
#define SM_DAT_PROG1                0x0055
#define SM_CMD_PROG2                0x0555
#define SM_DAT_PROG2                0x00A0

#define SM_CMD_CHPERASE0            0x0555
#define SM_DAT_CHPERASE0            0x00AA
#define SM_CMD_CHPERASE1            0x0AAA
#define SM_DAT_CHPERASE1            0x0055
#define SM_CMD_CHPERASE2            0x0555
#define SM_DAT_CHPERASE2            0x0080
#define SM_CMD_CHPERASE3            0x0555
#define SM_DAT_CHPERASE3            0x00AA
#define SM_CMD_CHPERASE4            0x0AAA
#define SM_DAT_CHPERASE4            0x0055
#define SM_CMD_CHPERASE5            0x0555
#define SM_DAT_CHPERASE5            0x0010

#define SM_CMD_SECERASE0            0x0555
#define SM_DAT_SECERASE0            0x00AA
#define SM_CMD_SECERASE1            0x0AAA
#define SM_DAT_SECERASE1            0x0055
#define SM_CMD_SECERASE2            0x0555
#define SM_DAT_SECERASE2            0x0080
#define SM_CMD_SECERASE3            0x0555
#define SM_DAT_SECERASE3            0x00AA
#define SM_CMD_SECERASE4            0x0AAA
#define SM_DAT_SECERASE4            0x0055
#define SM_CMD_SECERASE5            0x0000
#define SM_DAT_SECERASE5            0x0030

#define SM_FLASH_CMD_RESET()        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR, SM_DAT_RESET )

#define SECTOR_TOP          9
UINT32 SM_SECTOR[SECTOR_TOP] = { 0x00000000, 0x00002000, 0x00004000, 0x00006000, 0x00008000, 0x0000A000, 0x0000C000, 0x0000E000, 0x00010000 };

//==============================================================


//#define SECTOR_SHIFT_BIT            9
//#define SECTOR_SIZE                 (1<<SECTOR_SHIFT_BIT)

//#define FLASH_BASE_ADDR             SM_FLASH_BASE_ADDR
//#define BLOCK_SHIFT_BIT             SM_BLOCK_SHIFT_BIT
//#define BLOCK_SIZE                  SM_BLOCK_SIZE
//#define ADDRESS_TO_BLOCK(Addr)      ( Addr  >> BLOCK_SHIFT_BIT )
//#define BLOCK_TO_ADDRESS(Block)     ( Block << BLOCK_SHIFT_BIT )

//#define BASE_BLOCK                  ( ADDRESS_TO_BLOCK(FS_BASE_ADDRESS) )

//#define SECTOR_TO_ADDRESS(Sector)   ( (Sector<<SECTOR_SHIFT_BIT) )
//
//#define SECTOR_TO_BLOCK(Sector)     ( (Sector>>(BLOCK_SHIFT_BIT - SECTOR_SHIFT_BIT)) )
//#define BUFFER_TO_SECTOR_MASK       ( (1<<(BLOCK_SHIFT_BIT - SECTOR_SHIFT_BIT)) - 1)


//====================================== 16 nc ==========================================

//STATIC BOOL
//NOR_CheckStatus( UINT32 dwBlockAddr)
//{
//	UINT32  iTimeOut = 0;
//    UINT16  FirstState, SecondState;
//    
//    while(1)
//    {
//        FirstState = READ_REGISTER_USHORT(dwBlockAddr);
//        SecondState = READ_REGISTER_USHORT(dwBlockAddr);
//
//        if( SecondState == 0 )
//            return TRUE;
//        else
//        if( SecondState == 0x04)
//            return FALSE;
//        else
//        if( SecondState & 0x40 )
//        {
//            if( FirstState & 0x20 )
//                return FALSE;
//        }
//
//		iTimeOut++;
//		if( iTimeOut > 0xFFFFF)
//		{
//			console_printf("\n Timed out.\n");
//			return FALSE;
//		}
//    }
//
//    return TRUE;
//}

STATIC BOOL
NOR_IsBusy( UINT32 dwBlockAddr )
{
	//UINT32  iTimeOut = 0;
    VOLATILE UINT16  FstState, SndState;

    FstState = READ_REGISTER_USHORT(dwBlockAddr) & (1<<6);
    SndState = READ_REGISTER_USHORT(dwBlockAddr) & (1<<6);

    return FstState != SndState;
}


STATIC INT32 
NOR_Erase( INT32 iBlock )
{
    BOOL        bRet = FALSE;
    UINT32      dwBlockAddr;
    UINT32      i;
    UINT32      TimeOut;
    UINT32      nRetry = 0;

RETRY_ERASE:
    nRetry++;
    SM_FLASH_CMD_RESET();

	console_printf(" NOR_Erase : %d ",iBlock);

    if( iBlock != 31 )
    {
	    dwBlockAddr  =  SM_FLASH_BASE_ADDR + (iBlock << 16);	// 64K / Block

        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE0<<1), SM_DAT_SECERASE0 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE1<<1), SM_DAT_SECERASE1 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE2<<1), SM_DAT_SECERASE2 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE3<<1), SM_DAT_SECERASE3 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE4<<1), SM_DAT_SECERASE4 );
        WRITE_REGISTER_USHORT( dwBlockAddr, SM_DAT_SECERASE5 );

        TimeOut = 0;
        while( NOR_IsBusy(dwBlockAddr) )
        {
            if( nRetry > 10)
                goto ERR_ERASE_RETURN;
    
            if( TimeOut++ > 0xFFFFF )
                goto RETRY_ERASE;
        }
    
        // verify
        for( i = 0; i < SM_BLOCK_SIZE ; i += 4 )
            if( READ_REGISTER_USHORT( dwBlockAddr + i ) != 0xFFFF )
                goto RETRY_ERASE;
    
        bRet = TRUE;


        goto SUCCESS_ERASE_RETURN;
    }
    

    for( i = 0; i < SECTOR_TOP-1; i++)
    {

	    dwBlockAddr  =  SM_FLASH_BASE_ADDR + SM_FLASH_TOP_ADDR + SM_SECTOR[i];	// 64K / Block

        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE0<<1), SM_DAT_SECERASE0 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE1<<1), SM_DAT_SECERASE1 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE2<<1), SM_DAT_SECERASE2 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE3<<1), SM_DAT_SECERASE3 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE4<<1), SM_DAT_SECERASE4 );
        WRITE_REGISTER_USHORT( dwBlockAddr, SM_DAT_SECERASE5 );

        TimeOut = 0;
        while( NOR_IsBusy(dwBlockAddr) )
        {
            if( nRetry > 10)
                goto ERR_ERASE_RETURN;
    
            if( TimeOut++ > 0xFFFFF )
                goto RETRY_ERASE;
        }
    
        // verify
        for( i = 0; i < SM_BLOCK_SIZE ; i += 4 )
            if( READ_REGISTER_USHORT( dwBlockAddr + i ) != 0xFFFF )
                goto RETRY_ERASE;

    }
        bRet = TRUE;

SUCCESS_ERASE_RETURN:
	console_printf(" is erased.\n" );

ERR_ERASE_RETURN:
    SM_FLASH_CMD_RESET();


    return bRet;

}

STATIC INT32
NOR_Write( UINT32 iBlock, CHAR *pBuf )
{
    INT32       Ret = -1;
    UINT32      dwBlockAddr;
    UINT32      dwBlockAddrEnd;
    //UINT32      i;

console_printf("NOR_Write : %d \n", iBlock );


    dwBlockAddr = SM_FLASH_BASE_ADDR + (iBlock << 16);    // 128K / Block
//console_printf("NOR_Write : dwBlockAddr = %x\n",(UINT32)dwBlockAddr);
//console_printf("NOR_Write : pBuf = %x\n",(UINT32)pBuf);

    SM_FLASH_CMD_RESET();

    dwBlockAddrEnd = dwBlockAddr + SM_BLOCK_SIZE;

    while( dwBlockAddr < dwBlockAddrEnd )
    {
        //register VOLATILE UINT16    Temp;
        register UINT16             Data;
        INT32                       TimeOut;

        Data = *(PUINT16)(pBuf);
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG0<<1), SM_DAT_PROG0 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG1<<1), SM_DAT_PROG1 );
        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG2<<1), SM_DAT_PROG2 );  // Tell NOR_ to program..
        WRITE_REGISTER_USHORT( dwBlockAddr, Data );                                  // Copy it to NOR

        ///* Wait for operation to finish */
        TimeOut = 0;
        while( NOR_IsBusy(dwBlockAddr) )
        {
            if( TimeOut++ > 0xFFFFF )
                goto ERR_WRITE_RETURN;
        }

        //TimeOut = 0;
        //while( Temp = READ_REGISTER_USHORT( dwBlockAddr ), Temp != READ_REGISTER_USHORT( dwBlockAddr ) )
        //{
        //    if (++TimeOut > 0xFFFFFFF) 
        //        goto ERR_WRITE_RETURN;
        //}
        //

        /* Verify */
        if( READ_REGISTER_USHORT( dwBlockAddr ) != Data )
        {
            Ret = -2;
            goto ERR_VERIFY_RETURN;
        }
        
        dwBlockAddr += 2;
        pBuf += 2;
    }

    Ret = 0;

console_printf(" is programed. %d\n", Ret );

ERR_VERIFY_RETURN:
ERR_WRITE_RETURN:
    SM_FLASH_CMD_RESET();

    return Ret;

}








//void HY29LV320_Cmd_Reset(void)
//{   	
//	WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR, SM_DAT_RESET );
//}   
//
//
//static UINT32 flash_check_status( UINT32 dwBlockAddr)
//{
//	UINT32  iTimeOut = 0;
//    UINT16  FirstState, SecondState;
//    
//    while(1)
//    {
//        FirstState = READ_REGISTER_USHORT(dwBlockAddr);
//        SecondState = READ_REGISTER_USHORT(dwBlockAddr);
//
//        if( SecondState == 0 )  return TRUE;
//        else
//        if( SecondState == 0x04)    return FALSE;
//        else
//        if( SecondState & 0x40 )
//        {
//            if( FirstState & 0x20 ) return FALSE;
//        }
//
//		iTimeOut++;
//		if( iTimeOut > 0xFFFFF)
//		{
//			console_printf("\n Timed out.\n");
//			return FALSE;
//		}	
//    }
//
//}
//
//static UINT32 flash_erase_block(INT32 iBlock) //ULONG FlashEraseIBlock(ULONG dwBlock)
//{
//    UINT32  i;
//	UINT32	dwBlockAddr;
//
//	console_printf(" %d :",iBlock);
//
//HY29LV320_Cmd_Reset();
//
//    if( iBlock != 0 )
//    {
//	    dwBlockAddr  =  SM_FLASH_BASE_ADDR + (iBlock << 16);	// 64K / Block
//
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE0<<1), SM_DAT_SECERASE0 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE1<<1), SM_DAT_SECERASE1 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE2<<1), SM_DAT_SECERASE2 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE3<<1), SM_DAT_SECERASE3 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE4<<1), SM_DAT_SECERASE4 );delay(0x10000);
//        WRITE_REGISTER_USHORT( dwBlockAddr, SM_DAT_SECERASE5 );delay(0x10000);
//
//        flash_check_status( dwBlockAddr);
//
//    	console_printf(" is erased.\n" );
//        return 0;
//    }
//    
//
//    for( i = 0; i < SECTOR_TOP-1; i++)
//    {
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE0<<1), SM_DAT_SECERASE0 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE1<<1), SM_DAT_SECERASE1 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE2<<1), SM_DAT_SECERASE2 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE3<<1), SM_DAT_SECERASE3 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_SECERASE4<<1), SM_DAT_SECERASE4 );delay(0x10000);
//        WRITE_REGISTER_USHORT( SM_SECTOR[i], SM_DAT_SECERASE5 );delay(0x10000);
//
//        flash_check_status( dwBlockAddr);
//
//    	console_printf(" is erased.\n" );
//    }
//
//HY29LV320_Cmd_Reset();
//
//    return 0;
//
//}

static UINT32 flash_lock_block( INT32 iBlock)
{
//	UINT32	dwBlockAddr;
//
//	console_printf(" %d :",iBlock);
//
//	dwBlockAddr  =  SM_FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block
//
//	FLASH_CLEAR_GSTATUS(dwBlockAddr);
//
//	FLASH_LOCK_0(dwBlockAddr);
//	FLASH_LOCK_1(dwBlockAddr);
//	if( !flash_check_status(dwBlockAddr) )
//		return 0;
//	
//	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode
//
//	console_printf(" is locked.\n" );
	
	return 0;
}

static UINT32 flash_unlock_block( INT32 iBlock)
{
//	UINT32	dwBlockAddr;
//
//	console_printf(" %d :",iBlock);
//
//	dwBlockAddr  =  SM_FLASH_BASE_ADDR + (iBlock << 17);	// 128K / Block
//
//	FLASH_CLEAR_GSTATUS(dwBlockAddr);
//
//	FLASH_UNLOCK_0(dwBlockAddr);
//	FLASH_UNLOCK_1(dwBlockAddr);
//	if( !flash_check_status(dwBlockAddr) )
//		return 0;
//	
//	FLASH_READ_ARRAY(dwBlockAddr);	// Set Back to read array mode
//	
//	console_printf(" is unlocked.\n" );

	return 0;
}

//static UINT32 flash_program_block(UINT32 iBlock, CHAR *pData) 
//{
//	UINT32	dwBlockAddr;
//	INT32 i;
//
//console_printf("pData = %X\n",(UINT32)pData);
//console_printf(" %d :",iBlock);
//
//	// should be erased
//	//flash_erase_block(iBlock);
//	
//	dwBlockAddr  =  SM_FLASH_BASE_ADDR + (iBlock << 16);	// 64K / Block
//console_printf("dwBlockAddr = %X\n",(UINT32)dwBlockAddr);
//
//HY29LV320_Cmd_Reset();
//
//	for( i = 0; i < SM_BLOCK_SIZE; i+=2)
//	{
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG0<<1), SM_DAT_PROG0 );delay(0x100);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG1<<1), SM_DAT_PROG1 );delay(0x100);
//        WRITE_REGISTER_USHORT( SM_FLASH_BASE_ADDR + (SM_CMD_PROG2<<1), SM_DAT_PROG2 );delay(0x100);
//        WRITE_REGISTER_USHORT( dwBlockAddr+i, *(UINT16*)(pData+i) );                  delay(0x100);
//		//delay(0x100);
//	}
//
//HY29LV320_Cmd_Reset();
//
//	console_printf(" is programed.\n" );
//
//	return 0;
//
//}
UINT32 flash_lock( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_lock_block(iStart);

	return 0;
}
UINT32 flash_unlock( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		flash_unlock_block(iStart);

	return 0;
}
	
UINT32 flash_erase( INT32 iStart, INT32 iEnd)
{
	for( ; iStart <= iEnd; iStart++)
		NOR_Erase(iStart);

	return 0;
}

UINT32 flash_program( UINT32 iTarget, UINT32 iSource, UINT32 iSize)
{
	UINT32 iStart, iEnd;
	
	if( iTarget + iSize > 0x1000000)	//16M Flash 
	{
		console_printf("The paramenter is wrong\n");
		return 1;
	}

	iStart = (iTarget / SM_BLOCK_SIZE);
	iEnd = (iTarget + iSize + SM_BLOCK_SIZE-1)/SM_BLOCK_SIZE;

	for( ; iStart < iEnd; iStart++)
		NOR_Erase( iStart );
	
	iStart = (iTarget / SM_BLOCK_SIZE);
	iEnd = (iTarget + iSize + SM_BLOCK_SIZE-1)/SM_BLOCK_SIZE;

	for( ; iStart < iEnd; iStart++, iSource += SM_BLOCK_SIZE)
		NOR_Write(iStart, (CHAR *)iSource);

	return 0;
}
#endif
//================================================================================

VOID flash_operation( VOID )
{
	CHAR	*token;
	CHAR	op;
	
	
	/*
	 *  Get all the arguments.
	 */
	/* operation supplied? */
	token = __PULL() ;
	if ((token == NULL))
	{
		console_printf("\nERROR: you must supply an operation\n");
		return ;
	}
	if( token[1]!=0)
	{
		console_printf("\nERROR: incorrect operation\n");
		return;
	}
	op = *token;


	switch(op)
	{
	
	case 'e':
	case 'E':
	{
		INT32	iStart, iEnd;
		
		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iStart = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iEnd = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}
	
        if( op == 'e')
		    flash_erase(iStart, iEnd);
		else
		    flash_erase_32(iStart, iEnd);
		
		break;
	}
	case 'l':
	case 'L':
	{
		INT32	iStart, iEnd;

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iStart = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iEnd = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}
	
        if( op == 'l')
    		flash_lock(iStart, iEnd);
        else
	    	flash_lock_32(iStart, iEnd);
		
		break;
	}
	case 'u':
	case 'U':
	{
		INT32	iStart, iEnd;

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iStart = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an start block\n");
			return ;
		}
		iEnd = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}
	
        if( op == 'u')
    		flash_unlock(iStart, iEnd);
		else
    		flash_unlock_32(iStart, iEnd);

		break;
	}
	case 'p':
	case 'P':
	{
		UINT32	iSource, iTarget, iSize;

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an target address\n");
			return ;
		}
		iTarget = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}

		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an source address\n");
			return ;
		}
		iSource = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}
	
		token = __PULL() ;
		if ((token == NULL))
		{
			console_printf("\nERROR: you must supply an size\n");
			return ;
		}
		iSize = ston(token);
		if( E_ston )
		{
			console_printf("\nwrong parameter.\n") ;
			return;
		}

        if( op == 'p')
		    flash_program(iTarget, iSource, iSize);
		else
		    flash_program_32(iTarget, iSource, iSize);
		    
		break;
	}
	default :
		console_printf("\nERROR: incorrect operation\n");
		
	}

	return;
}

#endif

typedef VOID (*JUMPFUNC)( VOID);
extern UINT32 platform_start;

VOID run_JBOSN(VOID)
{
	CHAR	*token ;
	UINT32	dwAddr;

	JUMPFUNC    jumpfunc;

	/*
	 *  Get all the arguments.
	 */
	/* jump address supplied? */
	token = __PULL() ;
	if ((token == NULL))
	{
		E_ston = FALSE;
		dwAddr = platform_start + 8;
	}
	else
	{
		dwAddr = (UINT32)ston(token);
	}
	
	if( E_ston )
	{
		console_printf("\nwrong parameter.\n") ;
		return;
	}

	dwAddr = ((UINT32)dwAddr & ~0x3);
	
	jumpfunc = (JUMPFUNC)dwAddr;

//    console_printf("Now Start : 0x%x\n", dwAddr);
	jumpfunc();	
	return;	
	
}

