/* ld script to make ARM j-BOSN Operating System j-boot
 */

OUTPUT_ARCH(arm)

ENTRY(_entry)

SECTIONS
{
    . = 0x06f00000;

    _text = .;			/* Text and read-only data      */
    .text : 
    {
        *(.text.init) 
        *(.text)
        *(.fixup)
        *(.gnu.warning)
        *(.text.lock)	/* out-of-line lock text */
        *(.glue_7) 
        *(.glue_7t)
        *(.rodata)
        *(.rodata.*)
    }
    _etext = .;			/* End of text section          */

    . = ALIGN(4);
    _data = .;
    .data : {			/* Data                         */
        *(.data)
    }
    
    _edata = .;			/* End of data section          */
    
    _bss_start = .;		/* BSS                          */
    .bss : 
    {
        *(.bss)
    }
    _end = . ;
}
