/*	$ JBOSN : debug.c, v 0.1 2002/12/17 $	*/

/*
 * Copyright (C) 2002	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: debug.c
 *
 * Purpose: basic operation for debug tools
 *
 */
 
#include <types.h>

EXTERN VOID     ConsolePutChar(BYTE c);


#define MAXSTR	256

//STATIC  _prt10(), _prtl10(), _prt8(), _prtl8(), _prt16(), _prtl16(), _prt2(), _prtl2();


STATIC VOID
_prt10( UINT32 num, PCHAR str )
{
    INT     i;
    CHAR    temp[6];

    temp[0]	= '\0';
    for(i = 1; i <= 5; i++)  
    {
        temp[i] = num % 10 + '0';
        num /= 10;
    }
    for(i =	5; temp[i] == '0'; i--);
    if( i == 0 )
        i++;

    while( i >= 0 ) *str++ = temp[i--];

    return;
}

STATIC VOID
_prtl10( long num, PCHAR str)
{
    INT     i;
    CHAR    temp[11];

    temp[0]	= '\0';
    for(i = 1; i <= 10; i++)  
    {
        temp[i] = num % 10 + '0';
        num /= 10;
    }
    for(i = 10; temp[i] == '0'; i--);

    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}

STATIC VOID
_prt8( UINT32 num, PCHAR str)
{
    INT     i;
    //CHAR    c;
    CHAR    temp[7];

    temp[0]	= '\0';
    for(i = 1; i <= 6; i++)  
    {
        temp[i]	= (num & 07) + '0';
        num = (num >> 3) & 0037777;
    }
    temp[6] &= '1';
    for(i = 6; temp[i] == '0'; i--);
    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}

STATIC VOID
_prtl8( long num, PCHAR str)
{
    INT     i;
    CHAR    temp[12];

    temp[0]	= '\0';
    for(i = 1; i <= 11; i++)  
    {
        temp[i]	= (num & 07) + '0';
        num = num >> 3;
    }
    temp[11] &= '3';
    for(i = 11; temp[i] == '0'; i--);

    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}

STATIC VOID
_prt16( UINT32 num, PCHAR str )
{
    INT     i;
    CHAR    temp[5];
    
    temp[0] = '\0';
    for(i = 1; i <= 4; i++)  
    {
        temp[i] = "0123456789abcdef"[num & 0x0f];
        num = num >> 4;
    }
    for(i = 4; temp[i] == '0'; i--);

    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];
    
    return;
}

STATIC VOID
_prtl16( long num, PCHAR str )
{
    INT     i;
    CHAR    temp[9];

    temp[0] = '\0';
    for(i = 1; i <= 8; i++)  
    {
        temp[i] = "0123456789abcdef"[num & 0x0f];
        num = num >> 4;
    }
    for(i = 8; temp[i] == '0'; i--);

    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}



STATIC VOID
_prt2( UINT32 num, PCHAR str )
{
    INT     i;
    CHAR    temp[17];

    temp[0] = '\0';
    for(i = 1; i <= 16; i++)  
    {
        temp[i] = ((num%2) == 0) ? '0' : '1';
        num = num >> 1;
    }
    for(i = 16; temp[i] == '0'; i--);

    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}


STATIC VOID
_prtl2( long num, PCHAR str )
{
    INT     i;
    CHAR    temp[35];

    temp[0] = '\0';
    for(i = 1; i <= 32; i++)  
    {
        temp[i] = ((num%2) == 0) ? '0' : '1';
        num = num >> 1;
    }
    for(i = 32; temp[i] == '0'; i--);
    if( i == 0 )        i++;
    while( i >= 0 )     *str++ = temp[i--];

    return;
}



/*------------------------------------------------------------------------
 *  _doprnt --  format and write output using 'func' to write characters
 *------------------------------------------------------------------------
 *  all arguments passed as 4 bytes, long==int
 *
    fmt	    :   Format string for printf
    args    :   Arguments to	printf
    func    :   Function to put a character
 */
STATIC VOID
_doprnt( PCHAR fmt, INT *args, INT (*func)(INT))
{
    INT     c;
    INT     i;
    INT     f;              /* The format character	(comes after %) */
    PCHAR   str;            /* Running pointer in string            */
    CHAR    string[20];     /* The string str points to this output */
                            /*  from number conversion              */
    INT     length;         /* Length of string "str"               */
    CHAR    fill;		    /* Fill	character (' ' or '0')          */
    INT     leftjust;       /* 0 = right-justified,	else left-just. */
    INT     longflag;       /* != 0	for long numerics - not	used    */
    INT     fmax,fmin;      /* Field specifications	% MIN .	MAX s   */
    INT     leading;        /* No. of leading/trailing fill	chars.  */
    CHAR    sign;           /* Set to '-' for negative decimals     */
    CHAR    digit1;         /* Offset to add to first numeric digit */

    for(;;) 
    {
        /* Echo characters until '%' or end of fmt string */
        while( (c = *fmt++) != '%' ) 
        {
            if( c == '\0' )
                return;
            (*func)(c);
        }

        /* Echo "...%%..." as '%' */
        if( *fmt == '%' ) 
        {
            (*func)(*fmt++);
            continue;
        }

        /* Check for "%-..." == Left-justified output */
        if( (leftjust = ((*fmt=='-') ? 1 : 0) ) )
            fmt++;
        /* Allow for zero-filled numeric outputs ("%0...") */
        fill = (*fmt=='0') ? *fmt++ : ' ';
        /* Allow for minimum field width specifier for %d,u,x,o,c,s*/
        /* Also allow %* for variable width (%0* as well)	*/
        fmin = 0;
        if( *fmt == '*' ) 
        {
            fmin = *args++;
            ++fmt;
        }
        else 
        {
            while( '0' <= *fmt && *fmt <= '9' ) 
            {
                fmin = fmin * 10 + *fmt++ - '0';
            }
        }

        /* Allow for maximum string width for %s */
        fmax = 0;
        if( *fmt == '.' ) 
        {
            if( *(++fmt) == '*' ) 
            {
                fmax = *args++;
                ++fmt;
            }
            else 
            {   
                while( '0' <= *fmt && *fmt <= '9' ) 
                {
                    fmax = fmax * 10 + *fmt++ - '0';
                }
            }
        }

        /* Check for the 'l' option to force long numeric */
        if( (longflag = ((*fmt == 'l') ? 1 : 0)) )
            fmt++;

#ifndef INT_NOT_LONG
        longflag = 1;	/* all are 4 bytes on the Sun */
#endif				

        str = string;
        if( (f= *fmt++) == '\0' ) 
        {
            (*func)('%');
            return;
        }
        sign = '\0';	/* sign == '-' for negative decimal */

        switch( f ) 
        {
        case 'c' :
            string[0] = (CHAR) *args;
            string[1] = '\0';
            fmax = 0;
            fill = ' ';
            break;
            
        case 's' :
            str = (PCHAR)*args;
            fill = ' ';
            break;
            
        case 'D' :
            longflag = 1;
        case 'd' :
            if (longflag) 
            {
                if ( *(long *)args < 0) 
                {
                    sign = '-';
                    *(long *)args = -*(long *)args;
                }
            } 
            else 
            {
                if ( *args < 0 ) 
                {
                    sign = '-';
                    *args = -*args;
                }
            }

            longflag--;
        case 'U':
            longflag++;
        case 'u':
            if( longflag ) 
            {
                digit1 = '\0';
                /* "negative" longs in unsigned format	*/
                /* can't be computed with long division	*/
                /* convert *args to "positive", digit1	*/
                /* = how much to add back afterwards	*/
                while(*(long *)args < 0) 
                {
                    *(long *)args -= 1000000000L;
                    ++digit1;
                }
                _prtl10(*(long *)args, str);
                str[0] += digit1;
#ifdef INT_NOT_LONG				
                ++args;
#endif				
            } 
            else
                _prt10(*args, str);
            fmax = 0;
            break;

        case 'O' :
            longflag++;
        case 'o' :
            if ( longflag ) 
            {
                _prtl8(*(long *)args, str);
#ifdef INT_NOT_LONG				
                ++args;
#endif				
            } 
            else
                _prt8(*args, str);
            fmax = 0;
            break;

        case 'X' :
            longflag++;
        case 'x' :
            if( longflag ) 
            {
                _prtl16(*(long *)args, str);
#ifdef INT_NOT_LONG				
                ++args;
#endif				
            } 
            else
                _prt16(*args, str);
            fmax = 0;
            break;
            
        case 'B' :
            longflag++;
        case 'b' :
            if( longflag ) 
            {
                _prtl2(*(long *)args, str);
#ifdef INT_NOT_LONG				
                ++args;
#endif				
            } 
            else
                _prt2(*args, str);
            fmax = 0;
            break;
            
        default :
            (*func)(f);
            break;
        }

        args++;
        for(length = 0; str[length] != '\0'; length++);

        if ( fmin > MAXSTR || fmin < 0 )
            fmin = 0;
        if ( fmax > MAXSTR || fmax < 0 )
            fmax = 0;
        leading = 0;
        if ( fmax != 0 || fmin != 0 ) 
        {
            if ( fmax != 0 )
                if ( length > fmax )
                    length = fmax;
            if ( fmin != 0 )
                leading = fmin - length;
            if ( sign == '-' )
                --leading;
        }
        if( sign == '-' && fill == '0' )
            (*func)(sign);
        if( leftjust == 0 )
            for( i = 0; i < leading; i++ )
                (*func)(fill);
        if( sign == '-' && fill == ' ' )
            (*func)(sign);
        for( i = 0 ; i < length ; i++ )
            (*func)(str[i]);
        if ( leftjust != 0 )
            for( i = 0; i < leading; i++ )
                (*func)(fill);
	}

    return;
}



///void debug_printf(char *fmt, ...)
VOID console_printf(char *fmt, int args)
{
	_doprnt(fmt, &args, ConsolePutChar);
	return;
}
