#include <types.h>
#include <net/buflist.h>
#include <net/netdev.h>
#include <net/if_ether.h>

#include <string.h>

STATIC BYTE ether_buffer[1600];

VOID eth_setup(struct netdev *nd)
{
	INT32 i;

	nd->hw_addr_len = 6;

	for (i = 0; i < nd->hw_addr_len; i++)
		nd->hw_broadcast[i] = 0xff;
}

STATIC struct buflist *eth_header(struct netdev *nd, BYTE *to, UINT16 proto, struct buflist *blp)
{
	STATIC struct buflist bl;
	STATIC struct ethhdr  eth;

	bl.data = &eth;
	bl.size = 14;
	bl.next = blp;

	memcpy(eth.eth_source, nd->hw_addr, nd->hw_addr_len);
	memcpy(eth.eth_dest, to, nd->hw_addr_len);
	eth.eth_proto = htons(proto);

	return &bl;
}

STATIC INT32 eth_send(struct netdev *nd, struct buflist *data)
{
	struct buflist *blp;
	INT32 size = 0;

	for (blp = data; blp; blp = blp->next) {
		memcpy(ether_buffer + size, blp->data, blp->size);
		size += blp->size;
	}
	return nd->hard->send(nd, ether_buffer, size);
}

STATIC INT32 eth_recv(struct netdev *nd, UINT16 proto, BYTE *buffer)
{
	struct ethhdr *eth = (struct ethhdr *)ether_buffer;
	INT32 bytes;

	do {
		bytes = nd->hard->recv(nd, ether_buffer,1600);
	//console_printf("\neth_recv : proto = %x\n",proto);
//if(bytes>0)console_printf("eth_recv : bytes = %d\n",bytes);
		if (bytes < 14)
			continue;
//{
//	INT32 i;
//
//	console_printf("\neth_recv : eth_dest = ");
//	for(i = 0; i < 6; i++)
//		console_printf("%x.",eth->eth_dest[i]);
//	console_printf("\neth_recv : eth_source = ");
//	for(i = 0; i < 6; i++)
//		console_printf("%x.",eth->eth_source[i]);
//	console_printf("\neth_recv : hw_addr = ");
//	for(i = 0; i < 6; i++)
//		console_printf("%x.",nd->hw_addr[i]);
//
//	console_printf("\n");
//}
//console_printf("eth_recv : eth_proto = %x\n",eth->eth_proto);
//console_printf("eth_recv :     proto = %x\n",htons(proto));
		if (!memeq(eth->eth_dest, nd->hw_addr, nd->hw_addr_len))
			continue;


		if (eth->eth_proto == htons(proto)) 
		{
			bytes -= 14;
			memcpy(buffer, ether_buffer + 14, bytes);
			break;
		}
	} while (bytes);

	return bytes;
}

CONST struct trans_ops eth_trans_ops = {
	eth_header,
	eth_send,
	eth_recv
};
