#include <types.h>
#include <net/bootdev.h>
#include <net/netdev.h>

#include <console.h>

EXTERN INT32 do_tftp(VOID);


EXTERN struct netdev net_dev_ne2000;
EXTERN struct netdev net_dev_cs8900;
EXTERN struct downloadconfig	dnconfig;

struct netdev *selected_net_devs = &net_dev_cs8900;

STATIC INT32 net_init(VOID)
{
	if( selected_net_devs->hard->init() == 0 )
		selected_net_devs = NULL;

	return selected_net_devs ? 0 : -1;
}

STATIC INT32 net_start(VOID)
{
	if (!selected_net_devs)
		return -1;

	if (selected_net_devs->hard->open(selected_net_devs) == 0)
	{
		console_printf("open fail\n");
		return -1;
	}
		
	selected_net_devs->ip_addr = dnconfig.my_ip;

	return 0;
}

STATIC INT32 net_load(VOID)
{
	INT32 ret;

	ret = do_tftp();

	return ret;
}

STATIC INT32 net_stop(VOID)
{
	//struct netdev *nd;

	return 0;
}

struct bootdev boot_net = {
	"net",

	net_init,
	net_start,
	net_load,
	net_stop
};
