#include <types.h>
#include <net/bootdev.h>

#include <console.h>

EXTERN INT32 getcommand( CHAR *command) ;

struct downloadconfig	dnconfig;
EXTERN struct bootdev	boot_net;

STATIC CHAR	buffer[128];


EXTERN VOID recvTFTP( UINT32 address )
{
	CHAR 	*pbuf;
	INT32	ret;

	dnconfig.addr = (UINT32)address;


	if(boot_net.init())
	{
		console_printf(" network initialization failed.\n");
		return;
	}
	
	
	// configure the tftp
	do
	{
		INT32		i;

		console_printf("\nEnter IP : ");
		getcommand(buffer);

		pbuf = buffer;

		dnconfig.my_ip = 0;

		ret = 0;
		for(i = 0; i < 4; i++)
		{	
			INT32	rv;

			rv = -1;

			while(1)
			{
				if( *pbuf == '.' )
				{
					
					if( (rv > 255) || (rv < 0) )
					{
						ret = -1;
						break;
					}
					
					dnconfig.my_ip = (dnconfig.my_ip>>8) | (rv<<24);
					pbuf++;
					break;
				}
				else if( *pbuf == 0 )
				{
					if( i != 3)
					{
						ret = -1;
						break;
					}
				
					if( (rv > 255) || (rv < 0) )
					{
						ret = -1;
						break;
					}
					
					dnconfig.my_ip = (dnconfig.my_ip>>8) | (rv<<24);
					break;
				}				
				else if( (*pbuf>='0') && (*pbuf<='9') )
				{
					if(rv < 0)	rv = 0;
					
					rv = rv*10 + (*pbuf -'0');

				}
				else
				{
					ret = -1;
					break;
				}

				pbuf++;
			}	
	
			if( ret < 0)
			{
				console_printf("Warning : incorrect ip format\n ");
				break;
			}
		}

	}while( ret < 0);

	//console_printf(" my_ip = %x\n",dnconfig.my_ip);


	//console_printf("\nEnter Server IP : ");
	do
	{
		INT32		i;

		console_printf("\nEnter Server IP : ");
		getcommand(buffer);

		pbuf = buffer;

		ret = 0;
		for(i = 0; i < 4; i++)
		{	
			INT32	rv;

			rv = -1;

			while(1)
			{
				if( *pbuf == '.' )
				{
					
					if( (rv > 255) || (rv < 0) )
					{
						ret = -1;
						break;
					}
					
					dnconfig.server_ip = (dnconfig.server_ip>>8) | (rv<<24);
					pbuf++;
					break;
				}
				else if( *pbuf == 0 )
				{
					if( i != 3)
					{
						ret = -1;
						break;
					}
				
					if( (rv > 255) || (rv < 0) )
					{
						ret = -1;
						break;
					}
					
					dnconfig.server_ip = (dnconfig.server_ip>>8) | (rv<<24);
					break;
				}				
				else if( (*pbuf>='0') && (*pbuf<='9') )
				{
					if(rv < 0)	rv = 0;
					
					rv = rv*10 + (*pbuf -'0');

				}
				else
				{
					ret = -1;
					break;
				}

				pbuf++;
			}	
	
			if( ret < 0)
			{
				console_printf("Warning : incorrect ip format\n");
				break;
			}
		}

	}while( ret < 0);
	
	//console_printf("server IP : %x\n", dnconfig.server_ip );

	do
	{
		console_printf("Enter download file name : ");
		getcommand(buffer);
		pbuf = buffer;
		while( (*pbuf == ' ')||(*pbuf=='\t') )	pbuf++;
	}while(  *pbuf == 0);
	
	dnconfig.filename = pbuf;
	
	console_printf("Trying downloading the file %s", dnconfig.filename);
	console_printf(" to address %x ", dnconfig.addr);
	console_printf(" from %x.\n", dnconfig.server_ip);
	
	//console_printf("Trying download...\n");
	if (boot_net.start())
	{
		console_printf("download device failed.\n");
		return;
	}

	if (boot_net.load() != 0)
	{
		console_printf("Warning: download failed\n");
		return;
	}
	
	boot_net.stop();
	
	console_printf("download completed.\n");

	return;
}
