#ifndef _UDP_H
#define _UDP_H

// This is the format for the ethernet frame that is transmitted on the wire
typedef struct EthernetFrameHeaderlab {
	UINT16 wDestMAC[3];
	UINT16 wSrcMAC[3];
	UINT16 wFrameType;
	// Then the data
	// After the data is a 4 byte CRC
} EthernetFrameHeader;

// This is the format for an ARP packet
typedef struct ARPPacketFormatTag {

	UINT16 wHardwareType;
	UINT16 wProtocolType;
	BYTE bHardwareAddrSize;
	BYTE bProtocolAddrSize;
	UINT16 wOperation;
	UINT16 wSrcMAC[3];
	DWORD dwSrcIP;
	UINT16 wDestMAC[3];
	DWORD dwDestIP;

} ARPPacketFormat;

// This is the format for the IP packet header
typedef struct IPHeaderFormatTag {
	BYTE bVersionLength;
	BYTE bTypeOfService;
	UINT16 cwTotalLength;
	UINT16 wIdentification;
	UINT16 wFragment;
	BYTE bTimeToLive;
	BYTE bProtocol;
	UINT16 wCRC;
	DWORD dwSrcIP;
	DWORD dwDestIP;
	// Options can go in here
	// Then comes the data
} IPHeaderFormat;

// This is the format for the UDP packet header
typedef struct UDPHeaderFormatTag {
	UINT16 wSrcPort;
	UINT16 wDestPort;
	UINT16 cwTotalUDPLength;
	UINT16 wCRC;
	// Then comes the data
} UDPHeaderFormat;

// This is the format for the UDP packet header
typedef struct UDPPseudoHeaderFormatTag {
	DWORD dwSrcIP;
	DWORD dwDestIP;
	BYTE bZero;
	BYTE bProtocol;
	UINT16 cwTotalUDPLength;
} UDPPseudoHeaderFormat;

// Since the ethernet, IP, and UDP headers are fixed length, we can use this
// offset to write user data directly into frame buffer, saving a copy.
#define UDP_DATA_FRAME_OFFSET  (sizeof(EthernetFrameHeader) +  sizeof(IPHeaderFormat) + sizeof(UDPHeaderFormat))

#endif
