#ifndef _DRV_ADC_H_
#define _DRV_ADC_H_


/** ADC trigger modes */
typedef enum _TRIGGER_MODE_
{
    TRIGGER_MODE_SOFTWARE = 0,
    TRIGGER_MODE_ADTRG,
    TRIGGER_MODE_TIMER,
    TRIGGER_MODE_PERIOD,
}TRIGGER_MODE;

/** ADC test mode structure */
typedef struct _ADC_MODE_CONTROL_
{
    TRIGGER_MODE   TriggerMode;
    BOOL           bDmaEn;
    BOOL           bSequenceEn;
    BOOL           bGainEn;
    BOOL           bOffsetEn;
    BOOL           bPowerSaveEn;
    BOOL           bAutoCalibEn;
    UINT32         Period; // in ns
    UINT32         EnableChannels; 
} ADC_MODE_CONTROL;



/* Definitions for ADC channels */
#define ADC_CHANNEL_0  0
#define ADC_CHANNEL_1  1
#define ADC_CHANNEL_2  2
#define ADC_CHANNEL_3  3
#define ADC_CHANNEL_4  4
#define ADC_CHANNEL_5  5
#define ADC_CHANNEL_6  6
#define ADC_CHANNEL_7  7
#define ADC_CHANNEL_8  8
#define ADC_CHANNEL_9  9
#define ADC_CHANNEL_10 10
#define ADC_CHANNEL_11 11
#define ADC_CHANNEL_MAX 12
//#define ADC_CHANNEL_12 12
//#define ADC_CHANNEL_13 13
//#define ADC_CHANNEL_14 14
//#define ADC_CHANNEL_15 15

/** Total number of ADC channels in use */
#define NUM_CHANNELS    (ADC_CHANNEL_MAX)
/** ADC sample data */
typedef struct _AdcSampleData
{
    UINT16  wValue[NUM_CHANNELS];
    UINT16  wDone;
    UINT8   ucChNum[NUM_CHANNELS];
} tAdcSampleData;


#define IOCTRL_ADC_MODE               MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'A', 0)
#define IOCTRL_ADC_BUFFER             MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'A', 1)
#define IOCTRL_ADC_READ_SINGLE        MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'A', 2)
#define IOCTRL_ADC_READ_BUFFER        MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'A', 3)

#endif // _DRV_ADC_H_
