#ifndef __CAMERA_DRV_H__
#define __CAMERA_DRV_H__

#include <types.h>
#include <thread.h>
#include <message.h>


enum
{
    CAM_SIZE_QVGA,
    CAM_SIZE_CIF,
    CAM_SIZE_VGA,
    CAM_SIZE_SXGA
};

enum _CS_OUTPUT_
{
    OUTPUT_RGB,
    OUTPUT_YUV
};

typedef enum
{
    CS_PROPERTY_BRIGHTNESS,
    CS_PROPERTY_COLOR,
    CS_PROPERTY_CC,
    CS_PROPERTY_HSYNC,
    CS_PROPERTY_VSYNC,
    CS_PROPERTY_CLKPOL,
    CS_PROPERTY_EMB_SYNC,
    CS_PROPERTY_BARCOLOR
}CS_PROPERTY_TYPE;

typedef struct _CS_PROPERTY_
{
    CS_PROPERTY_TYPE    Type;
    UINT32              Value;
}CS_PROPERTY, *CS_PPROPERTY;


typedef struct _CS_DEVINFO_
{
    UINT32      Width;
    UINT32      Height;
    UINT32      vSyncHighActive;
    UINT32      hSyncHighActive;
    UINT32      CodecFb;
    UINT32      PreviewFb;
}CS_DEVINFO, *CS_PDEVINFO;

typedef struct _CS_PREVIEWINFO_
{
    UINT32              Width;
    UINT32              Height;
    UINT32              nBpp;
    UINT32              PreviewAddr;
    UINT32              CodecAddr;
    enum _CS_OUTPUT_    csOutput;
}CS_PREVIEWINFO, *CS_PPREVIEWINFO;

#define IOCTL_CS_RESET               MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 0)
#define IOCTL_CS_GET                 MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 9)
#define IOCTL_CS_SET                 MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 10)
#define IOCTL_CS_SETSIZE             MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 1)
#define IOCTL_CS_BMPIMG              MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 2)
#define IOCTL_CS_END                 MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 3)
#define IOCTL_CS_SETPREVIEW          MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 4)
#define IOCTL_CS_START               MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 8)
#define IOCTL_CS_ENABLE_PATH         MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 5)
#define IOCTL_CS_PROPERTY            MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 6)
#define IOCTL_CS_GETINFO             MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 7)
#define IOCTL_CS_CAPTURE             MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 11)
#define IOCTL_CS_SELECT              MESSAGE_DEVICE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE, 'C', 12)

/*
#if 1
#define BOARD_LCD_WIDTH             640 //480 //640
#define BOARD_LCD_HEIGHT            480 //272 //480
#else
#define BOARD_LCD_WIDTH             1280 //480 //640
#define BOARD_LCD_HEIGHT            1024 //480 //272 //480
#endif
*/

#endif //	__CAMERA_DRV_H__

