#ifndef _DISPLAY_DRV_H_
#define _DISPLAY_DRV_H_

//===========================================================================
enum
{
    CHANNEL_BASE,
    CHANNEL_VIDEO,
    CHANNEL_POPUP,
    CHANNEL_CURSOR,
    CHANNEL_POPUP2,
    CHANNEL_MAX,
};

typedef struct _CHANNELCMD_
{
    UINT32  Channel;
    UINT32  Type;
    UINT32  Param;
    UINT32  Ret;
}CHANNELCMD;

enum 
{
    CHANNEL_CMD_CHECK_CHANNEL,          // check the support of the channel
    CHANNEL_CMD_GET_SDI,                // get / set the sdi of the layer
    CHANNEL_CMD_GET_DIRECT_SDI,
    CHANNEL_CMD_SET_SDI,
    CHANNEL_CMD_GET_BASECOLOR,          // get / set the base color of the layer
    CHANNEL_CMD_SET_BASECOLOR,
    CHANNEL_CMD_GET_TRANSPARENTCOLOR,   // get / set the transparent of the layer
    CHANNEL_CMD_SET_TRANSPARENTCOLOR,
    CHANNEL_CMD_GET_ALPHA,              // get / set the alpha value of the layer for the blending
    CHANNEL_CMD_SET_ALPHA,
    CHANNEL_CMD_GET_ROTATE,             // get / set the rotate angle of the layer
    CHANNEL_CMD_SET_ROTATE,
    CHANNEL_CMD_GET_POS,                // get / set the position of the layer
    CHANNEL_CMD_SET_POS,
    CHANNEL_CMD_GET_SIZE,               // get / set the size of the layer
    CHANNEL_CMD_SET_SIZE,
    CHANNEL_CMD_GET_CONTROL,            // get / set the operation on/off
    CHANNEL_CMD_SET_CONTROL,
    CHANNEL_CMD_ENABLE_TRANSPARENTCOLOR,
    CHANNEL_CMD_ENABLE_ALPHA,
};

#define DEFAULT_TRANSPARENT_COLOR   (0x00FF00FF);

#define DISPLAY_CHANNEL_CONTROL     (0x00008001)


#define CURSOR_WIDTH    32
#define CURSOR_HEIGHT   32

#define CAMERA_WIDTH    640
#define CAMERA_HEIGHT   480

//===========================================================================

#endif // _DISPLAY_DRV_H_
