/*	$ JBOSN_OS: debug.h, v 0.1 2003/05/13 $	*/

/*
 * Copyright (C) 2002	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: debug.h
 *
 * Purpose: debug function definitions.
 *
 */
#ifndef __HAL_PANIC_H_
#define __HAL_PANIC_H_

#include <types.h>


EXTERN VOID kprintf(const char *, ...);
EXTERN VOID panic(const char *, ...); 

#define DEBUG_TRUE

#ifdef DEBUG_TRUE
    #define DEBUG1(b,a)     {if((b)) kprintf(a);}
    #define DEBUG2(b,a,p)   {if((b)) kprintf((a),(p));}
    #define DEBUGMSG(b,fmt,arg...)      {if((b))    kprintf(fmt, ##arg);}

    #define DBGLINE(b,fmt,arg...)   {if((b)){ kprintf("%s(%d):",__FUNCTION__,__LINE__); kprintf(fmt, ##arg);}}

    #define HEXDUMP_R(b, src, len, row)  \
    {                                                                           \
        if (b)                                                                  \
        {                                                                       \
            int i;                                                              \
            for (i = 0; i < len; ++i)                                           \
            {                                                                   \
                if (row && (i % row == 0)) kprintf("\n");                       \
                kprintf("%02X ", src[i]);                                       \
            }                                                                   \
            kprintf("\n");                                                      \
        }                                                                       \
    }
    #define HEXDUMP(b, src, len)    HEXDUMP_R(b, src, len, 0)
    #define HEXDUMP16(b, src, len)  HEXDUMP_R(b, src, len, 16)
    
#else
    #define DEBUG1(b,a) {}
    #define DEBUG2(b,a,p) {}
    #define DEBUGMSG(b,fmt,arg...)      {}

    #define DBGLINE(b,fmt,arg...)   {}
    #define HEXDUMP_R(b, src, len, row)	{}
	#define HEXDUMP(b, src, len)	{}
	#define HEXDUMP16(b, src, len)	{}
    
#endif



EXTERN VOID     PanicInit( VOID );
EXTERN VOID     Panic(PBYTE Str);

EXTERN VOID     ConsoleInit( VOID );
EXTERN INT32    ConsoleRead( PBYTE p_Buffer, UINT32 n);
EXTERN VOID     ConsoleWrite( PBYTE p_Str);
EXTERN VOID     ConsolePutChar( BYTE Ch);

#endif /* __HAL_PANIC_H_ */



