#ifndef _SAMA5D3XBD_H_
#define _SAMA5D3XBD_H_

#include <moduleloader.h>

/* ******************************************************************* */
/* PMC Settings                                                        */
/*                                                                     */
/* The main oscillator is enabled as soon as possible in the c_startup */
/* and MCK is switched on the main oscillator.                         */
/* PLL initialization is done later in the hw_init() function          */
/* ******************************************************************* */
//#define MASTER_CLOCK		    (132096000)
//#define PLL_LOCK_TIMEOUT	    1000000

#define BOARD_MAINOSC           12000000
//#define BOARD_MCK               ((unsigned long)((BOARD_MAINOSC / 3 / 2 / 3) * 200 )) // 133MHz
#define BOARD_MCK               ((unsigned long)((BOARD_MAINOSC / 3 / 2 ) * 66 )) // 132MHz
//#define BOARD_OSCOUNT           (AT91C_CKGR_OSCOUNT & (64 << 8))
//#define BOARD_CKGR_PLLA         (AT91C_CKGR_SRCA | AT91C_CKGR_OUTA_0)
//#define BOARD_PLLACOUNT         (0x3F << 8)
//#define BOARD_MULA              (AT91C_CKGR_MULA & (199 << 16))
//#define BOARD_DIVA              (AT91C_CKGR_DIVA & 3)
//#define BOARD_PRESCALER         (0x00001300)

/*
//#define PLLA_SETTINGS           ( BOARD_CKGR_PLLA \
//                                | BOARD_PLLACOUNT \
//                                | BOARD_MULA \
//                                | BOARD_DIVA)
*/

////#define PLLA_SETTINGS	0x202A3F01
//#define PLLUTMI
//#define PLLUTMI_SETTINGS	0x10193F05
//
///* Switch MCK on PLLA output PCK = PLLA/2 = 3 * MCK */
//#define MCKR_SETTINGS		(AT91C_PMC_CSS_MAIN_CLK | BOARD_PRESCALER)
//#define MCKR_CSS_SETTINGS	(AT91C_PMC_CSS_PLLA_CLK | BOARD_PRESCALER)

#if 0
// UDP
//#define UDC_VBUS_IRQ_PIN_NUM		29
//#define AT91C_VBUS              AT91C_PIO_PD29
#define UDC_VBUS_IRQ_PIN_NUM		25
#define AT91C_VBUS              AT91C_PIO_PD25
#define AT91C_PIO_VBUS          AT91C_BASE_PIOD
#define AT91C_ID_VBUS           SAMA5D3_ID_PIOD

// UHC
#define AT91C_UHC_SLOT1_EN              AT91C_PIO_PD19
#define AT91C_UHC_SLOT1_FLG             AT91C_PIO_PB17
#define AT91C_UHC_SLOT2_EN              AT91C_PIO_PD20
//#define AT91C_UHC_SLOT2_FLG             AT91C_PIO_PD4

// SDCARD
//#define AT91C_MCI_MCI0_WP       AT91C_PIO_PD17
//#define AT91C_MCI_MCI1_WP       AT91C_PIO_PD29
//#define AT91C_MCI_MCI2_WP       AT91C_PIO_PD29
#define AT91C_MCI_MCI0_CD       AT91C_PIO_PD17
#define AT91C_MCI_MCI1_CD       AT91C_PIO_PD19
//#define AT91C_MCI_MCI2_CD       AT91C_PIO_PD11
#define AT91C_PIO_MCI           AT91C_BASE_PIOD
//#define AT91C_ID_MCI            AT91C_ID_PIOD_E
#endif

#if 0
// DISPLAY
#define DMA_DISPLAY_F_BASE      0x7005b000
#define DMA_DISPLAY_I_BASE      0x700da800
#define DMA_BUFFER_BASE         0x70008000

#define DMA_BUFFER_BASE         0x70008000

#define DMA_AUDIO               (DMA_BUFFER_BASE + 0)
#define DMA_SDMMC               (DMA_AUDIO + 4096*4)
#define DMA_USART               (DMA_SDMMC + 4*1024*4)
#define DMA_USART_RX0           (DMA_USART + 0)
#define DMA_USART_TX0           (DMA_USART + 2048)
#define DMA_USART_END0          (DMA_USART + 2048 + 512)
#define DMA_USART_RX1           (DMA_USART_END0 + 0)
#define DMA_USART_TX1           (DMA_USART_END0 + 2048)
#define DMA_USART_END1          (DMA_USART_END0 + 2048 + 512)
#define DMA_USART_RX2           (DMA_USART_END1 + 0)
#define DMA_USART_TX2           (DMA_USART_END1 + 2048)
#define DMA_USART_END2          (DMA_USART_END1 + 2048 + 512)


#define DMA_EMACB               (0x70018000)
        #define MACB_DMADESC_SIZE       8
        #define RX_RING_SIZE		    512
        #define RX_BUFFER_SIZE		    128
        #define RX_BUFFER_SIZE_SHIFT    7
        #define TX_RING_SIZE		    128
        #define TX_BUFFER_SIZE          0x600       /* 1518 rounded up */
    #define DMA_EMACB_SIZE          ((MACB_DMADESC_SIZE+RX_BUFFER_SIZE)*RX_RING_SIZE + (MACB_DMADESC_SIZE+TX_BUFFER_SIZE)*TX_RING_SIZE )
//#else
        #define MACB_DMADESC_SIZE       8
        #define RX_RING_SIZE		    512
        #define RX_BUFFER_SIZE		    128
        #define RX_BUFFER_SIZE_SHIFT    7
        #define TX_RING_SIZE		    128
        #define TX_BUFFER_SIZE          0x600       /* 1518 rounded up */
    #define DMA_EMACB_SIZE          ((MACB_DMADESC_SIZE+RX_BUFFER_SIZE)*RX_RING_SIZE + (MACB_DMADESC_SIZE+TX_BUFFER_SIZE)*TX_RING_SIZE )
#endif

//===========================================================================================================
#define MAX_KERNEL_MODULE     		9
#define INDEX_KERNEL_MODULE_LAST	9
#define MAX_KERNEL_MODULE_LOAD	    (MAX_KERNEL_MODULE + 1 )
PUBLIC UINT32                       aKernelLoaded[MAX_KERNEL_MODULE_LOAD];

//===========================================================================================================
#define DMAC_0			0
#define DMAC_1			1
#define MAX_DMAC_NUM	(DMAC_1 + 1)

typedef struct _SHARED_MEMORY_
{
    UINT32          aKernelLoaded[MAX_KERNEL_MODULE_LOAD];
    LOADER_CONFIG   LoaderConfig;
	UINT32			DMAC_reg_EBCISR[MAX_DMAC_NUM];//130125 AC
    /* use for the other */

    UINT32          InputCount;
    UINT32          BootMode; // 
    #define WARM_BOOTMODE   0x3A73B001

    UINT32          KeepBuffer; //32KB

    struct {
        UINT32      Data[16]; // 64byte align
    }VideoLayer[5] __attribute__((aligned(64)));;   // 5 layer

    UINT32          RotateAngle;

    INT32          xCursor;
    INT32          yCursor;

    INT32          TouchBootCorner;

}SHARED_MEMORY, *PSHARED_MEMORY;
#define SHARED_MEMORY_BASE       0x8000

#endif
