/*	$ JBOSN : idle.c, v 0.1 10-12-03 15:13 $	*/

/*
 * Copyright (C) 2003	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: idle.c
 *
 * Purpose: idle thread.
 *
 */

#include <types.h>
#include <thread.h> 
#include <interrupt.h>
#include <panic.h>

// Idle thread stack size in byte
//PUBLIC UINT32   IdleStackSize = 128*4;

#define IDLESTACK_SIZE (512)
BYTE IdleStack[IDLESTACK_SIZE];

PUBLIC VOID
Idle_main( VOID )
{
    INT32   i = 0;

    DEBUG1(1,"From here, Idle_main ..\n");

#if 0
IF ({ARCHITECTURE} = "6"):LOR:({ARCHITECTURE} = "6K"):LOR:({ARCHITECTURE} = "6T2"):LOR:({ARCHITECTURE} = "6Z")
MOV R0, #0
MCR p15, 0, r0, c7, c0, 4
ELIF ({ARCHITECTURE} = "5T"):LOR:({ARCHITECTURE} = "5TE"):LOR:({ARCHITECTURE} = "5TEJ")
MOV R0, #0
MCR p15, 0, r0, c7, c0, 4
ELIF ({ARCHITECTURE} = "7"):LOR:({ARCHITECTURE} = "7-A"):LOR:({ARCHITECTURE} = "7-R"):LOR:({ARCHITECTURE} = "7-M")
WFI
ELSE
NOP
ENDIF
#endif

	for(;;)
	{
#if 1
        //INTERRUPT_OFF();
        asm("dsb");
                    //@ WFI may enter a low-power mode
        asm("wfi");
        //INTERRUPT_ON();
		i++;
		if( !(i %0x10000000) ) DEBUGMSG(1,"Idle Thread %X\n",i);
        //kprintf(".");

 #else
		if( !(i %0x10000000) ) DEBUGMSG(1,"Idle Thread %X\n",i);
        //kprintf(".");
		i++;
#endif
	}

	
	return;
}

THREADCONFIG IdleConfig = 
{NULL, Idle_main, IdleStack, IDLESTACK_SIZE, 0};





/*
  Name: HAL_PowerOff()
  Copyright: 
  Author: jung byoung oh
  Date: 10-12-03 15:18
  Description: power management routine 
               enter JBOSN RTOS  into suspend mode
*/
PUBLIC VOID
HAL_PowerOff( VOID )
{
//    INT32       i;
//    UINT32      PmuClk;

    DEBUG1(1,"HAL_PowerOff ..\n");

//    PmuClk = READ_REGISTER_ULONG( PMUCLK );
//
//    WRITE_REGISTER_ULONG(PMUSTAT, 0x7FF);       // clear status register
//    WRITE_REGISTER_ULONG(PMUSTAT, /*PMUSTAT_HOTSYNCINTR|PMUSTAT_MRINGINTR|*/PMUSTAT_WAKEUPINTR);       // key, modem RI, HotSync 
//
//    WRITE_REGISTER_ULONG(PMUMODE, PMUMODE_MODEDEEPSLEEP|PMUMODE_MODEWAKEUP);
//
//    i = READ_REGISTER_ULONG( PMUSTAT );
//
//    // sleep here
//    
//    // wakeup from here
//
//    // wait for a while
//    for( i = 0; i  < 10000; i++ );
//
//    WRITE_REGISTER_ULONG(PMUMODE, PMUMODE_MODERUN);
//    WRITE_REGISTER_ULONG(PMUSTAT, 0x1FF);       // clear status register
//    WRITE_REGISTER_ULONG(PMUSTAT, 0x7FF);       // clear status register
//
//    WRITE_REGISTER_ULONG(PMUCLK, PmuClk);

    DEBUG1(1,"HAL_PowerOn ..\n");


    return;
}

