/*	$ JBOSN : KernelLoad.c, v 0.1 2007-10-29 11:25E?AAu $	*/

/*
 * Copyright (C) 2003	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: KernelLoad.c
 *
 * Purpose: kernel loading 
 *
 */

#include <types.h>
#include <thread.h>
#include <time.h>
#include <device.h>
#include <nano_boot.h>

#include <lib/string.h>
#include <hal_panic.h>

#include "cache.h"

#include <mach/SAMA5D3X.h>
#include <mach/SAMA5D3Xbd.h>


//===========================================================================================================
#define MAX_KERNEL_MODULE     		9
#define INDEX_KERNEL_MODULE_LAST	9
#define MAX_KERNEL_MODULE_LOAD	    (MAX_KERNEL_MODULE + 1 )
//PUBLIC UINT32                   aKernelLoaded[MAX_KERNEL_MODULE_LOAD];
EXTERN THREADCONFIG             KernelConfig[];
EXTERN NKERNEL_BOOT    			HalBoot;
//===========================================================================================================
VOID console_printf(char *fmt, int args)
{
	//_doprnt(fmt, &args, ConsolePutChar);
	return;
} 

PUBLIC UINT32
KernelLoad( VOID )
{
    INT32   i;
    PSHARED_MEMORY  pSharedMemory = (PSHARED_MEMORY)SHARED_MEMORY_BASE;

//kprintf("kernelload: \n");

if( pSharedMemory->BootMode ==  WARM_BOOTMODE )
{
//    INT32           i;
//    UINT32          nRead;
    UINT32          UploadAdd;
//    PSHARED_MEMORY  pSharedMemory = (PSHARED_MEMORY)SHARED_MEMORY_BASE;
//    UploadAdd = 0x20009000;

    extern void dataflash_clear(void);
    extern PlatformReadFunction(PBYTE pBuffer, UINT32 StartOffset, INT32 ReadLen );

    dataflash_clear( );
    /* read the platform.bin location */
//    nRead = LoadPlatformLen( UploadAdd, PlatformReadFunction, 8 );

//    platform_start = *(PUINT32)(UploadAdd + 0);
//    UploadAdd = *(PUINT32)(UploadAdd + 4);

    /* read the platform.bin */
//    nRead = LoadPlatform( platform_start, PlatformReadFunction );

    /* read the kernels */
    UploadAdd = pSharedMemory->aKernelLoaded[1];

//    for( i = 0 ; i < MAX_KERNEL_MODULE_LOAD; i++ )
//        pSharedMemory->aKernelLoaded[i] = -1;
//
//    pSharedMemory->aKernelLoaded[0] = 0;

    LoadKernel( UploadAdd, pSharedMemory->aKernelLoaded, PlatformReadFunction, 0x06100000 /* temporary heap*/);

//    EXTERN LOADER_CONFIG  RomLoaderConfig;
//    pSharedMemory->LoaderConfig = RomLoaderConfig;
}
    pSharedMemory->TouchBootCorner = 0;

    /*-------------------------------------------------------------------------*/
    /*                temporary root fs access functions                       */
    /*-------------------------------------------------------------------------*/
    EXTERN LOADER_CONFIG LoaderConfig;
    LoaderConfig = pSharedMemory->LoaderConfig;
    EXTERN VOID CacheRangeFlush(VOID *pAddress, UINT32 Length, UINT32 Flags);
    LoaderConfig.pCacheRangeFlush = CacheRangeFlush;

//kprintf( "kernelload: LoaderConfig = %x\n", LoaderConfig);
//kprintf( "KernelLoad : Open = %x\n", LoaderConfig.pOpen );
//kprintf( "KernelLoad : Read = %x\n", LoaderConfig.pRead );
//kprintf( "KernelLoad : CacheRangeFlush = %x\n", LoaderConfig.pCacheRangeFlush );

/*
    HANDLE (*pOpen) ( PBYTE pFileName);
    INT32  (*pRead)( HANDLE hFile, BYTE *pBuf, UINT32 Length, UINT32 Offset );
    VOID   (*pCacheRangeFlush)(VOID *pAddress, UINT32 Length, UINT32 Flags);
*/
//{
//    HANDLE  h;
//    h = LoaderConfig.pOpen ((PBYTE)"fs_ram.drv");
//    DEBUGMSG(1, "%s (%d): %x\n", __FUNCTION__, __LINE__, h );
//    h = LoaderConfig.pRead ( h, BufTemp, 300, 0 );
//    DEBUGMSG(1, "%s (%d): %x\n", __FUNCTION__, __LINE__, h );
//    
//}


    /*-------------------------------------------------------------------------*/
    /*                          kernel servers location                        */
    /*-------------------------------------------------------------------------*/
    for( i = 0; i < MAX_KERNEL_MODULE; i++ )
    {
//        kprintf( "pSharedMemory->aLoaded = 0x%x\n", pSharedMemory->aKernelLoaded[i] );
        //if( aKernelLoaded[i] == -1 )
        if( i > 0 )
        {
            KernelConfig[i-1].pFunc = (THREADFUNC)pSharedMemory->aKernelLoaded[i];
        }
    }

//    kprintf( "aLoaded = %X\n", pSharedMemory->aKernelLoaded[i] );

    if( HalBoot.FreeMemoryStart == -1 )
    {
        pSharedMemory->KeepBuffer = pSharedMemory->aKernelLoaded[INDEX_KERNEL_MODULE_LAST];
        HalBoot.FreeMemoryStart = pSharedMemory->aKernelLoaded[INDEX_KERNEL_MODULE_LAST] + 32*1024; // 32KB
    }

    PUBLIC VOID CacheRangeFlushClear( VOID );
    CacheRangeFlushClear();
    CacheRangeFlush(NULL, 0, CACHE_SYNC_WRITEBACK |
                             CACHE_SYNC_INSTRUCTIONS |
                             CACHE_SYNC_FLUSH_I_TLB |
                             CACHE_SYNC_FLUSH_D_TLB |
                             0
                             );

    UINT32 BootAddr = pSharedMemory->aKernelLoaded[0];
//    if( pSharedMemory->BootMode ==  WARM_BOOTMODE )
//    {
//        UINT32 *p = (UINT32 *)(BootAddr + 0x4C);
//        BootAddr = *p;
//    }

    return BootAddr;
}


