//-----------------------------------------------------------------------------
//! \addtogroup	OAL
//! @{
//!
//  All rights reserved ADENEO SAS 2005
//!
//-----------------------------------------------------------------------------
//! \file		AT91SAM926x/KERNEL/INTR/intr.c
//!
//! \brief		implements the interrupt engine
//!
//! \if subversion
//!   $URL: http://centaure/svn/interne-ce_atmel_common/TAGS/V150-Nadia1-19-Sept-2006/AT91SAM926x/KERNEL/INTR/intr.c $
//!   $Author: jjhiblot $
//!   $Revision: 278 $
//!   $Date: 2006-07-24 15:25:58 +0200 (lun., 24 juil. 2006) $
//! \endif
//-----------------------------------------------------------------------------



//#include <windows.h>
//#include <ceddk.h>
//#include <nkintr.h>
//#include <oal.h>
//#include <oal_intr.h>
//#include <intr.h>
//#include "AT91SAM926x.h"
//#include "lib_AT91SAM926x.h"
//#include "AT91SAM926x_oal_intr.h"
//#include "AT91SAM926x_oal_timer.h"
//#include "pio_intr.h"

#include <types.h>
#include <mach/AT91SAM926x.h>


//------------------------------------------------------------------------------
//
//  Globals.


//PFN_PROFILER_ISR g_pProfilerISR = NULL;
//DWORD g_dwProfilerIRQ = 0xFFFFFFFF;
//
//static DWORD AICResumeMask;
//static AT91PS_AIC pAIC = 0;
//AT91PS_SYS pSYS = 0;
//
///// This function initialize interrupt mapping, hardware and call platform specific initialization.
//BOOL OALIntrInit()
//{
//    BOOL result = TRUE;
//    int i;
//       
//    RETAILMSG(1, (L"+OALIntrInit\r\n") );
//	pSYS = (AT91PS_SYS) OALPAtoVA((DWORD)AT91C_BASE_SYS,FALSE);
//
//	// Setting pAIC
//	if (pAIC == 0)
//	{
//		pAIC = (AT91PS_AIC) OALPAtoVA((DWORD)AT91C_BASE_AIC,FALSE);
//
//		//Sanity Check
//		if (pAIC == NULL)
//		{
//			RETAILMSG(1, (L"+%s OALPAtoVA((DWORD)AT91C_BASE_AIC,FALSE) failed \r\n",__FUNCTION__ ));
//			return FALSE;
//		}
//	}
//	
//	//Sanity Check
//	if (pSYS == NULL)
//	{
//		RETAILMSG(1, (L"+%s OALPAtoVA((DWORD)AT91C_BASE_SYS,FALSE) failed \r\n",__FUNCTION__ ));
//		return FALSE;
//	}
//
//    // Disable all interrupts
//    pSYS->SYS_AIC_IDCR = -1;
//    // clear all interrupts
//    pSYS->SYS_AIC_ICCR = -1;
//    
//    // Configure the AIC to correctly manage the interrupts from the peripheral controllers.
//    // Later the user would be able to change those properties by calling a kernelIoControl (IOCTL_HAL_SET_IRQ_PROPERTIES -not implemented yet-)
//    // in order for example to handle interrupt on IRQ0-IRQ6
//    for (i = 0; i <= LOGINTR_AIC_LAST; i++) 
//    {
//		// Create an IRQ descriptor for each AIC entry
//		// Init each SMR AIC entry
//		pSYS->SYS_AIC_SVR[i] = i;
//		pSYS->SYS_AIC_SMR[i] = AT91C_AIC_PRIOR_LOWEST | AT91C_AIC_SRCTYPE_INT_LEVEL_SENSITIVE;
//
//		// Perform 8 End Of Interrupt Command to make sure AIC will not Lock out nIRQ
//		if (i < 8)
//			pSYS->SYS_AIC_EOICR = pSYS->SYS_AIC_EOICR;
//
//    }
//
//    // Initialize interrupt mapping
//    OALIntrMapInit();
//    
//    // Initialize PIO controllers
//    SOCPioIntrInit();
//
//#ifdef OAL_BSP_CALLBACKS    
//	/// \note this functions gives a chance to the BSP to perform something specific here like to initializing a subordinate controller
//    result = BSPIntrInit();
//#endif
//
//    RETAILMSG(1, (L"-OALIntrInit(rc = %d)\r\n", result));
//	// Disable all interrupts
//	 
//    return result;
//}
//
//
///// Turns the interrupt source off
/////
///// Update the register on the target which masks the irq passed to the CPU.
///// \param irq
///// \param pOldState pointer to a BOOLEAN indicating if the interrupt was previously enabled
//BOOL SOCDisableIrq(DWORD irq,BOOL* pOldState)
//{
//		// RETAILMSG(1, ( L"+SOCDisableIrq(%d)\r\n", irq ));
//    	// Depending on IRQ number use AIC or PIO controler register
//        if ((irq >= LOGINTR_AIC_FIRST) && (irq <= LOGINTR_AIC_LAST)) {
//            // Use AIC interrupt register
////            RETAILMSG(1, ( L"+SOCDisableIrq(%d) AIC mask %x\r\n", irq , (1<<irq)));
//			if (pOldState!=NULL)
//			{
//				*pOldState = pAIC->AIC_IMR & (1<<irq);
//			}
//            pAIC->AIC_IDCR = (1<<irq);
//        } 
//        else 
//        {
//        	//try to use PIO registers
//        	if (SOCDisablePioIrq(irq, pOldState) == FALSE)
//        		return FALSE;
//           
//        }
//	return TRUE;
//}


/// Turn the interrupt source on.
///
/// Update the register on the target which masks the irq passed to the CPU.
BOOL SOCEnableIrq(DWORD irq)
{	
    // Depending on IRQ number use AIC or PIO controler register
    if ((irq >= LOGINTR_AIC_FIRST) && (irq <= LOGINTR_AIC_LAST)) 
    {
        // Use AIC interrupt register
        //RETAILMSG(1, ( L"+SOCEnableIrq(%d) AIC mask %x\r\n", irq , (1<<irq)));
        pAIC->AIC_IECR = (1<<irq);
    } 
    else 
    {
        //try to use PIO registers
        if (SOCEnablePioIrq(irq) == FALSE)
        return FALSE;
    }
	return TRUE;
}

///// Save interrupts mask and turn all interrupt sources off.
/////
///// This function is called before entering suspend.
//void SOCSaveAndDisableAllIntrBeforeSuspend()
//{
//	RETAILMSG(1, ( L"+SOCSaveAndDisableAllIntrBeforeSuspend()\r\n" )); 	
// 	AICResumeMask = pAIC->AIC_IMR;
//	pAIC->AIC_IDCR = 0xFFFFFFFF; //mask all the interrupts
//	SOCPioSaveAndDisableAllIntrBeforeSuspend();
//	SOCPioControllerIntrEnable(); //Leave the interrupt for the pio controllers !
//}
//
///// retore the previously backed-up interrupt mask (\sa SOCSaveAndDisableAllIntrBeforeSuspend)
/////
///// This function is called juste before leaving suspend mode
//void SOCRestoreAllIntrAfterSuspend()
//{
//	RETAILMSG(1, ( L"+SOCRestoreAllIntrAfterSuspend()\r\n" ));
//	pAIC->AIC_IECR = AICResumeMask;
//	SOCPioRestoreAllIntrAfterSuspend();	
//}
//
///// This function returns IRQs for CPU/SoC devices based on their physical address. 
//BOOL OALIntrRequestIrqs(DEVICE_LOCATION *pDevLoc, UINT32 *pCount, UINT32 *pIrqs)
//{
//    BOOL rc = FALSE;
//
//    RETAILMSG(1, (
//        L"+OALIntrRequestIrqs(0x%08x->%d/%d/0x%08x/%d, 0x%08x, 0x%08x)\r\n",
//        pDevLoc, pDevLoc->IfcType, pDevLoc->BusNumber, pDevLoc->LogicalLoc,
//        pDevLoc->Pin, pCount, pIrqs
//    ));
//
//    // This shouldn't happen
//    if (*pCount < 1) goto cleanUp;
//
//#ifdef OAL_BSP_CALLBACKS
//	/// \note this functions gives a chance to the BSP to perform something specific here
//    rc = BSPIntrRequestIrqs(pDevLoc, pCount, pIrqs);
//#endif    
//
//cleanUp:        
//    RETAILMSG(1, (L"-OALIntrRequestIrqs(rc = %d)\r\n", rc));
//    return rc;
//}
//
//
///// OAL function to enable IRQs based on their physicall interrupt number
//BOOL OALIntrEnableIrqs(UINT32 count, const UINT32 *pIrqs)
//{
//    BOOL rc = TRUE;
//    UINT32 i, irq;
//
//  //  RETAILMSG(1, (        L"+OALIntrEnableIrqs(%d, 0x%08x)\r\n", count, pIrqs ));
//
//    for (i = 0; i < count; i++) {
//#ifndef OAL_BSP_CALLBACKS
//        irq = pIrqs[i];
//#else
//		/// \note this functions gives a chance to the BSP to perform something specific here like enabling irq on subordinate interrupt controller
//        irq = BSPIntrEnableIrq(pIrqs[i]);
//#endif
//        if (irq == OAL_INTR_IRQ_UNDEFINED) continue;
//        
//        if (SOCEnableIrq(irq) == FALSE)
//        	rc = FALSE;
//    }        
//
//      //RETAILMSG(1, (L"-OALIntrEnableIrqs (rc=%d) (AIC_IMR = 0x%x)\r\n",rc,AT91C_VA_BASE_SYS->AIC_IMR));
// return rc;    
//}
//
//
///// OAL function to disable IRQs based on their physicall interrupt number
//VOID OALIntrDisableIrqs(UINT32 count, const UINT32 *pIrqs)
//{
//    UINT32 i, irq;
//
//    RETAILMSG(1, (
//        L"+OALIntrDisableIrqs(%d, 0x%08x)\r\n", count, pIrqs
//    ));
//
//    for (i = 0; i < count; i++) {
//#ifndef OAL_BSP_CALLBACKS
//        irq = pIrqs[i];
//#else
//		/// \note this functions gives a chance to the BSP to perform something specific here like disabling irq on subordinate interrupt controller
//        irq = BSPIntrDisableIrq(pIrqs[i]);
//#endif
//        if (irq == OAL_INTR_IRQ_UNDEFINED) continue;
//        
//        SOCDisableIrq(irq, 0);
//    }        
//    //RETAILMSG(1, (L"-OALIntrDisableIrqs (AIC_IMR = 0x%x)\r\n",AT91C_VA_BASE_SYS->AIC_IMR));
//}
//
//
///// OAL function to finish IRQs based on their physicall interrupt number
/////
///// \note On this architecture this is mostly the same as enabling the interrupt
//VOID OALIntrDoneIrqs(UINT32 count, const UINT32 *pIrqs)
//{
//    UINT32 i, irq;
//
//   // RETAILMSG(1, (   L"+OALIntrDoneIrqs(%d, 0x%08x)\r\n", count, pIrqs));
//
//    for (i = 0; i < count; i++) {
//#ifndef OAL_BSP_CALLBACKS
//        irq = pIrqs[i];
//#else
//		/// \note this functions gives a chance to the BSP to perform something specific here like finishing the irq on subordinate interrupt controller
//        irq = BSPIntrDoneIrq(pIrqs[i]);
//#endif    
//       if (irq == OAL_INTR_IRQ_UNDEFINED) continue;
//        
//        // Depending on IRQ number use AIC or PIO controler register
//        
//        SOCEnableIrq(irq);
//     }
//
//
//    //RETAILMSG(1, (L"-OALIntrDoneIrqs (AIC_IMR = 0x%x)\r\n",AT91C_VA_BASE_SYS->AIC_IMR));
//}
//
//
//
////------------------------------------------------------------------------------
///// This is the main Interrupt handler
///// \param ra is reserved for future use. In case of a kernel with profiler enabled it's the location of the PC when the interrupt occured
//////------------------------------------------------------------------------------
//int OEMInterruptHandler(unsigned int ra)
//{
//	static AT91PS_SYS pSys = NULL;	   	
//	ULONG nSysIntr = SYSINTR_NOP;
//	DWORD nIVR;
//    extern volatile UINT32 g_oalLastSysIntr;
//	DWORD dwTempCountSinceSysTick = OALTimerCountsSinceSysTick();
//
//	//Sanity Check
//	if (pSys == NULL)
//	{
//		pSys = (AT91PS_SYS) OALPAtoVA((DWORD)AT91C_BASE_SYS,FALSE);
//		if (pSys == NULL)
//		{
//			RETAILMSG(1, (L"+%s OALPAtoVA((DWORD)AT91C_BASE_SYS,FALSE) failed \r\n",__FUNCTION__ ));
//			return SYSINTR_NOP;
//		}
//	}
//
//	nIVR = pSys->SYS_AIC_IVR;
//
//    /// First aknowledge the interrupt at the AIC level
//	pSys->SYS_AIC_EOICR = pSys->SYS_AIC_EOICR;
//
//	/// Then check if it's a system controller interrupt
//	if (nIVR == AT91C_ID_SYS) 
//	{
//		/// if a System Timer Interrupt occured, then call the timer interrupt handler
//	    if (pSys->SYS_PITC_PISR & AT91C_PITC_PITS) 
//	    {
//	        nSysIntr = OALTimerIntrHandlerWithILTSupport(dwTempCountSinceSysTick);
//		}
//#if 0	    
//	    else if (XXXXXXX) //Other system controller interrupt management
//	    {
//	        
//	    }
//#endif	    
//	    
//	}
//	/// if a profiler Interrupt occured, then call the profiler interrupt handler
//	else if ((nIVR == g_dwProfilerIRQ) && (g_pProfilerISR))
//	{
//		nSysIntr = g_pProfilerISR(ra); 
//	}
//	/// If this is another interrupt then it must be a device's interrupt
//    else
//    {
//		DWORD oldInt = nIVR;
//        //
//        
//        //
//// /////////////////////////////////////////////////////////// 1.36s
//		/// \par
//    	/// First let the SOC-dedicated interrupt susbsytem check if this is a pio interrupt
//    	nIVR = SOCIntrActiveIrq(nIVR);
///////////////////////////////////////////////////////////////
//
//#ifdef OAL_BSP_CALLBACKS
//		/// \par
//        /// Then let the BSP-specific interrupt susbsytem check if it wants to say that's another interrupt number (think of secondary interrupt controller on board, then it makes sense)
//        nIVR = BSPIntrActiveIrq(nIVR);
//#endif
//		
//		// ////////////////////////////////////////////////////////// 880ns
//		/// \par
//		/// Mask the interrupt so that it won't occur again before being finished with SOCInterruptDone
//		if (nIVR != LOGINTR_UNDEFINED)
//		{
//			SOCDisableIrq(nIVR, 0);
//			
//			/////////////////////////////////////////////////////////////
//			
//			
//			// /////////////////////////////////////////////////////  1.7s
//			/// \par
//			/// Then find if IRQ is claimed by chain (see NKCallIntChain and LoadIntrChainHandler in PB doc)
//			nSysIntr = NKCallIntChain((UCHAR)nIVR);
//			
//			if (nSysIntr == SYSINTR_CHAIN || !NKIsSysIntrValid(nSysIntr))
//			{
//				/// \par
//				/// \par
//				/// If the IRQ wasn't claimed by the chain, we use static LOGINTR -> SYSINTR mapping.
//				nSysIntr = OALIntrTranslateIrq(nIVR);
//			}
//			
//			/////////////////////////////////////////////////////
//			
//			// ///////////////////////////////////////////////////////////////////  2.8s
//			
//			if (nSysIntr == SYSINTR_NOP)
//			{
//				/// \par
//				/// \par
//				///If not a valid sysintr then put the inteerupt back to normal (enabled)
//				/// \note what's the point to enabling an interrupt that's handled ?.......
//				/// answer is : To do some ISR treatment only !
//				/// \warning Beware that this a flaw in the robustness of the kernel; If an interrupt is triggered 
//				/// and not acknowledged at the peripheral level, it may trigger again and again ... and again. And the system will be stopped in this loop
//				EdbgOutputDebugString( "Reenabling interrupt %d (nSysIntr %d)\r\n",nIVR,nSysIntr);
//				SOCEnableIrq(nIVR);
//				
//			} 
//			else  if (nSysIntr == SYSINTR_UNDEFINED)
//			{
//				//EdbgOutputDebugString( "Undefined Sysintr %d (nSysIntr %d)\r\n",nIVR,nSysIntr);
//				nSysIntr = SYSINTR_NOP;
//			}
//			else  if (!NKIsSysIntrValid(nSysIntr))
//			{
//				//EdbgOutputDebugString( "Invalid Sysintr %d (nSysIntr %d)\r\n",nIVR,nSysIntr);
//				nSysIntr = SYSINTR_NOP;
//			}
//			
//			////////////////////////////////////////////////////////////////////////
//			
//		}
//	}
//	
//    ///save the last Sysintr value. It's used by the suspend system and the fake idle routine
//	g_oalLastSysIntr = nSysIntr; 
//    
//	return nSysIntr;
//}


//------------------------------------------------------------------------------
//! @}


////////////////////////////////////////////////////////////////////////////////
// End of $URL: http://centaure/svn/interne-ce_atmel_common/TAGS/V150-Nadia1-19-Sept-2006/AT91SAM926x/KERNEL/INTR/intr.c $
////////////////////////////////////////////////////////////////////////////////
//
// History : $Log$
// History : Revision 1.14  2006/07/04 08:57:56  jjhiblot
// History : differenciate valid sysintr, sysintr_nop (ISR treatment only, sysintr_undefined and not valid sysintr
// History :
// History : Revision 1.13  2006/06/07 10:02:40  jjhiblot
// History : INTR : fixed issue. if an interrupt occures that the ISR doesn't want to be signaled to the user-space IST it simply return LOGINTR_UNDEFINED
// History :
// History : Revision 1.12  2005/11/18 15:18:49  jjhiblot
// History : Enhanced and fixed doxygen support
// History :
// History : Revision 1.11  2005/10/27 09:02:15  jjhiblot
// History : Cleanup
// History :
// History : Revision 1.10  2005/09/23 07:23:28  jjhiblot
// History : Fiw the code for prefast
// History :
// History : Revision 1.9  2005/09/14 13:40:12  dmartin
// History : Added FIQ
// History :
// History : Revision 1.8  2005/07/21 09:07:46  dmartin
// History : DMR : Doxy+CVS
// History :
// History : Revision 1.7  2005/07/19 08:02:36  jjhiblot
// History : Modified CVS headers to work with dOxygen
// History :
// History : Revision 1.6  2005/07/06 17:16:15  jjhiblot
// History : Modified CVS headers
// History :
// History : Revision 1.5  2005/06/30 12:39:06  dmartin
// History : DMR :
// History : Bug fix in RTC
// History : PLL support improved
// History : Processor Clock Selection
// History : USB Host added
// History :
// History : Revision 1.4  2005/06/17 10:00:32  dmartin
// History : DMR : Various changes :
// History :
// History : Revision 1.3  2005/05/24 17:07:38  jjhiblot
// History : *** empty log message ***
// History :
// History : Revision 1.2  2005/05/24 09:00:46  jjhiblot
// History : BUG fix : link errors (interrupts' lib)
// History : Debug messages clean up
// History : Bug fix : pio interrupt using the mask better than before
// History :
// History : Revision 1.1  2005/05/17 08:34:09  jjhiblot
// History : -NadiaX support
// History : -AT91SAM9261EK BSP
// History :
