/*	 dooroos.RealTime: kernel_main.c 	*/

/*
 * Copyright (C) 2011	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

#include <types.h>
#include <thread.h>
#include <moduleloader.h>
#include <network.h>


#define TIMESERVERSTACK_SIZE        (512 )
#define SYSTEMSERVERSTACK_SIZE      (1024)
#define SYNCSERVERSTACK_SIZE        (1024)
#define IOSERVERSTACK_SIZE          (1024)
#define FSSERVERSTACK_SIZE          (4096)
#define WNSERVERSTACK_SIZE          (4096)
#define NWSERVERSTACK_SIZE          (4096)
#define LOADERSERVERSTACK_SIZE      (4096)

STATIC UINT32       TimeServerStack  [TIMESERVERSTACK_SIZE>>2  ];
STATIC UINT32       SystemServerStack[SYSTEMSERVERSTACK_SIZE>>2];
STATIC UINT32       SyncServerStack  [SYNCSERVERSTACK_SIZE>>2  ];
STATIC UINT32       IOServerStack    [IOSERVERSTACK_SIZE>>2    ];
STATIC UINT32       FSServerStack    [FSSERVERSTACK_SIZE>>2    ];
STATIC UINT32       WNServerStack    [WNSERVERSTACK_SIZE>>2    ];
STATIC UINT32       NWServerStack    [NWSERVERSTACK_SIZE>>2    ];
STATIC UINT32       LoaderServerStack[LOADERSERVERSTACK_SIZE>>2];

enum 
{
    TIMER_THREAD = 0,
    SYSTEM_THREAD,
    SYNC_THREAD,

    IO_THREAD,
    FS_THREAD,
    WN_THREAD,
    NW_THREAD,

    LOADER_THREAD,
    MAX_THREAD
};



#define MAX_IO_DEVICE		30      // NOT USED ANYMORE
#define MAX_BLOCK_DEVICE	6       // NOT USED ANYMORE
#define MAX_DISPLAY_DEVICE  4
STATIC NW_PROTOCOL_CONFIG   NetConfig = 
								{
									DEFAULT_MAX_SOCKET_LIST,
									DEFAULT_MAX_TCP_PCB,
									DEFAULT_MAX_UDP_PCB,
									DEFAULT_MAX_RAW_PCB,
									DEFAULT_MAX_NET_PORT,
									DEFAULT_MAX_NETBUFS*20,
									DEFAULT_MAX_LRGBUFS,
									DEFAULT_NET_IF
								};

PUBLIC LOADER_CONFIG LoaderConfig;

PUBLIC THREADCONFIG KernelConfig[MAX_THREAD] =
{
    {NULL, (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)TimeServerStack, TIMESERVERSTACK_SIZE  , 
                                THREAD_PRIORITY_MICROKERNEL_TIME},
    {NULL, (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)SystemServerStack, SYSTEMSERVERSTACK_SIZE, 
                                THREAD_PRIORITY_MICROKERNEL_SYSTEM},
    {NULL, (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)SyncServerStack, SYNCSERVERSTACK_SIZE, 
                                THREAD_PRIORITY_MICROKERNEL_SYNC},

    { (UINT32)MAX_IO_DEVICE,     (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)IOServerStack, IOSERVERSTACK_SIZE, 
                                THREAD_PRIORITY_KERNEL_IOSERVER},
    { (UINT32)MAX_BLOCK_DEVICE, (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)FSServerStack, FSSERVERSTACK_SIZE, 
                                THREAD_PRIORITY_KERNEL_FSSERVER},
    { (UINT32)MAX_DISPLAY_DEVICE, (THREADFUNC)0xFFFFFFFF, 
                                (PBYTE)WNServerStack, WNSERVERSTACK_SIZE, 
                                THREAD_PRIORITY_KERNEL_WNSERVER},
    { (UINT32)&NetConfig,       (THREADFUNC)0xFFFFFFFF,
                                (PBYTE)NWServerStack, NWSERVERSTACK_SIZE,
                                THREAD_PRIORITY_KERNEL_NWSERVER},

    { (UINT32)&LoaderConfig,    (THREADFUNC)0xFFFFFFFF,
                                (PBYTE)LoaderServerStack, LOADERSERVERSTACK_SIZE,
                                THREAD_PRIORITY_KERNEL_LOADER},
};





