/* 
 * ld script to make dooroos.RealTime Operating System memory layout. 
 * refer the relcation part of "locore.S"
 * Written by iBOSN systems
 */


/* our program's entry point; not useful for much except to make sure the S7 record is proper, 
 *  because the reset vector actually defines the entrypoint in most embedded systems
 */

/* a list of files to link (others are supplied on the command line) */

OUTPUT_ARCH(arm)
ENTRY(stext)

/* list of our memory sections */

MEMORY
{
    nkernel       :  o = 0x00000000 ,                             	  l =   16K
    MMU_buf     :  o = 0x00000000 + 16K,                     	  l =   16K 
    MemShare   :  o = 0x00000000 + 16K + 16K,        	          l =   4K
    ram            :  o = 0x00000000 + 16K + 16K + 4K,             l =   128M  - (16K + 16K + 4K)
}


/* section description */
SECTIONS
{

	  .init : 
	  {
	      _startof_platform = .;

	      _text = .;		/* Text and read-only data	*/
	      hal_locore.o(.text.init)
	      _end_init = .;

	  } > ram

	  .ARM.exidx : 
	  {
	      __exidx_start = .;
	      *(.ARM.exidx* .gnu.linkonce.armexidx.*)
	      __exidx_end = .;
	  } > ram

	 /* TEXT */
	.text : 
	{
			*(.text)
			*(.text.*)
			*(.fixup)
			*(.gnu.warning)
			*(.text.lock)	/* out-of-line lock text */
			*(.glue_7) 
			*(.glue_7t)
			*(.rodata)
			*(.rodata.*)
		     . = ALIGN(4);
		  _etext = ALIGN(4);		/* End of text section		*/
	} > ram


	 /* DATA */
	.data :
	{
		/*
		 * and the usual data section
		 */
	       . = ALIGN(4);
	       _sdata = .;
		*(.data)
		. = ALIGN(4);
		_edata = .;
	} > ram


	/* BSS */
	.bss :
	{
		__bss_start = .;
		*(.bss)
		*(COMMON)
	    _end = ALIGN(4);
	}  > ram

	 _startof_ram = .;


    _endofram = 0x00000000 + 128M;

}
